
{Bemess.inc}

procedure StahlBemessung;
const
  Emodul                        = 2.1E8;
  SigmaMax :array[1..2] of real = (14.0,21.0);
var
  ErfI,ErfW,DeltaSoll :real;
  D,Stahlguete        :integer;

  procedure Eingabe(var Delta :real; var N,Guete :integer);
  begin
    clrscr;
    repeat
      gotoxy(1,1); write('Eingabe der Stahlguete 1 = St-37   2 = St-52 : ');
      ReadInteger(Guete); writeln
    until Guete in [1,2];
    writeln('Begrenzung der maximalen Durchbiegung auf 1/x');
    write('Eingabe x : '); ReadInteger(N); writeln;
    Delta:=Feldlaenge/N
  end;

  function Durchbiegung :real;
  var
    DeltaH,
    Momentenflaeche,
    Haelfte,
    Step,
    MomAufA,
    Resultort,
    Summe,Dummy      :real;
    I                :integer;

    function Simpson(Ort,dH :real):real;
    var
      Moment1,Moment2,Moment3,Q :real;
    begin
      Schnittkraft(Ort,Moment1,Q);
      Schnittkraft(Ort+dH,Moment2,Q);
      Schnittkraft(Ort+2*dH,Moment3,Q);
      Simpson:=dH/3*(Moment1+4*Moment2+Moment3)
    end;

  begin
    Momentenflaeche:=0; Haelfte:=0;
    DeltaH:=Feldlaenge/20;
    for I:=0 to 9 do Momentenflaeche:=Momentenflaeche+Simpson(2*I*DeltaH,DeltaH);
    Dummy:=Feldlaenge/2; Step:=1;
    repeat
      DeltaH:=Dummy/10; Haelfte:=0;
      for I:=0 to 4 do Haelfte:=Haelfte+Simpson(2*I*DeltaH,DeltaH);
      if Haelfte > Momentenflaeche/2 then
      begin
        Dummy:=Dummy-Step;
        Step:=Step/10
      end;
      Dummy:=Dummy+Step
    until abs(Haelfte-Momentenflaeche/2) < 0.01;
    Resultort:=round(Dummy*100)/100;
    MomAufA:=(Feldlaenge-Resultort)/Feldlaenge*Momentenflaeche;
    Summe:=MomAufA*Resultort;
    DeltaH:=Resultort/10;
    for I:=0 to 4 do Summe:=Summe-Simpson(2*I*DeltaH,DeltaH)*(Resultort-(2*I+1)*DeltaH);
    Durchbiegung:=Summe
  end;

  procedure Ausgabe;
  begin
    clrscr;
    writeln('Bemessung als Stahltraeger');
    writeln('==========================');
    writeln;
    write('Stahlguete : St-');
    case Stahlguete of
      1 : writeln('37');
      2 : writeln('52')
    end;
    writeln('erforderliches Traegheitsmoment    = ',ErfI:7:0,' cm4');
    writeln('bei einer maximalen Durchbiegung von 1 /',D:4,' = ',DeltaSoll*100:5:2,' cm');
    writeln('erforderliches Widerstandsmoment   = ',ErfW:7:0,' cm3');
    writeln('bei einer maximalen Spannung Sigma = ',SigmaMax[Stahlguete]:5:2,' kN/cm2')
  end;

begin
  Eingabe(DeltaSoll,D,Stahlguete);
  ErfI:=Durchbiegung/Emodul/DeltaSoll*1E8;
  ErfW:=MaxMoment*100/SigmaMax[Stahlguete];
  Ausgabe
end;

procedure BetonBemessung;
type
  Betonart = (B15,B25,B35,B45,B55);
  Error    = (M,Q,Ok);
  Test     = set of Error;
  String3  = string[3];
var
  Betonguete      :Betonart;
  Erfolg1,Erfolg2 :Error;
  Kontrolle       :Test;
  Schubbereich    :String3;
  Nochnicht       :boolean;
  Hoehe,StatHoehe,
  Breite,
  VorhKz,VorhKs,
  AsM,AsQ,Step,
  MaxTau,Tau,
  Moment,
  Querkraft,
  Ort,Abstand     :real;
  I,Teilung       :integer;

  procedure Eingabe;
  var
    Help :integer;
  begin
    repeat
      write('Wahl der Betonguete : 1=B15,2=B25,..,5=B55 : ');
      ReadInteger(Help); writeln
    until Help in [1..5];
    Betonguete:=Betonart(Help);
    writeln;
    write('Rechteckquerschnitt :      Eingabe der Hoehe [cm] : ');
    ReadReal(Hoehe); writeln;
    write('                              und der Breite [cm] : ');
    ReadReal(Breite); writeln;
    write('Abstand der Bewehrungsachse vom unteren Rand [cm] : ');
    ReadReal(Abstand); writeln;
    StatHoehe:=Hoehe-Abstand;
    writeln;
    write('Teilung : ');
    ReadInteger(Teilung); writeln
  end;

  procedure BemessungM(Moment :real; var Ks,Kz :real; var Fehler :Error);
  const
    KhTab :array[1..5,1..13] of real =
                ((9.09,5.49,4.14,3.33,2.98,2.75,2.60,2.51,2.46,2.40,2.34,2.28,2.22),
                 (7.04,4.25,3.21,2.58,2.31,2.13,2.01,1.94,1.90,1.86,1.81,1.77,1.72),
                 (6.14,3.71,2.80,2.25,2.01,1.86,1.75,1.69,1.66,1.62,1.58,1.54,1.50),
                 (5.67,3.43,2.58,2.08,1.86,1.72,1.62,1.56,1.53,1.50,1.46,1.42,1.38),
                 (5.38,3.25,2.45,1.97,1.76,1.63,1.54,1.48,1.45,1.42,1.38,1.35,1.31));
    KsTab :array[1..13] of real =
                 (3.6,3.7,3.8,3.9,4.0,4.1,4.1,4.2,4.2,4.3,4.4,4.4,4.5);
    KzTab :array[1..13] of real =
                 (0.97,0.95,0.93,0.90,0.88,0.87,0.85,0.84,0.83,0.82,0.81,0.79,0.78);
  var
    VorhKh :real;
    I      :integer;
  begin
    Fehler:=Ok; Ks:=0; Kz:=1;
    VorhKh:=StatHoehe/sqrt(Moment/Breite*100);
    if VorhKh < KhTab[ord(Betonguete),13] then Fehler:=M
    else
    begin
      for I:=1 to 12 do
        if VorhKh < KhTab[ord(Betonguete),I] then
        begin
          Ks:=KsTab[I+1];
          Kz:=KzTab[I+1]
        end
    end
  end;

  procedure BemessungQ(Querkraft,Kz :real; var mT,T :real;
                                           var Bereich :String3; var Fehler :Error);
  const
    T012 :array[1..5] of real = (0.050,0.075,0.100,0.110,0.125);
    T02  :array[1..5] of real = (0.120,0.180,0.240,0.270,0.300);
    T03  :array[1..5] of real = (0.200,0.300,0.400,0.450,0.500);
  begin
    Fehler:=Ok;
    if mT > T03[ord(Betonguete)] then Fehler:=Q;
    mT:=Querkraft/Breite/Kz/StatHoehe;
    if mT <= T012[ord(Betonguete)] then
    begin
      Bereich:='I';
      T:=0.4*mT
    end;
    if (T012[ord(Betonguete)] < mT) and (mT <= T02[ord(Betonguete)]) then
    begin
      Bereich:='II';
      T:=mT*mT/T02[ord(Betonguete)];
      if T < 0.4*mT then T:=0.4*mT
    end;
    if (T02[ord(Betonguete)] < mT) and (mT <= T03[ord(Betonguete)]) then
    begin
      Bereich:='III';
      T:=mT
    end
  end;

  procedure Ausdruck(Fehler1,Fehler2 :Error);
  begin
    if I = 0 then
    begin
      clrscr;
      writeln('Bemessung als Stahlbetontraeger');
      writeln('===============================');
      writeln;
      writeln('Materialgueten :         Stahl: BSt 500 S');
      writeln('                         Beton: B ',chr(ord(Betonguete)+48),'5');
      writeln('Querschnittswerte        d/b/h: ',
                                        Hoehe:6:2,'/',Breite:6:2,'/',StatHoehe:6:2,' cm');
      writeln;
      writeln('  x      Moment As-unten    Querkraft   tau 0 Schub-    tau As-Buegel');
      writeln('  m         kNm      cm2           kN   MN/m2 bereich MN/m2     cm2/m');
      writeln
    end;
    if (Fehler1 = Ok) and (Fehler2 = Ok) then
      writeln(Ort:5:2,Moment:10:2,AsM:9:2,Querkraft:13:2,
              10*MaxTau:8:3,Schubbereich:5,10*Tau:9:3,AsQ:10:2);
    if Fehler1 = M then
      writeln(Ort:5:2,Moment:10:2,'  *******',Querkraft:13:2,
                                  '  ******************************');
    if Fehler2 = M then
      writeln(Ort:5:2,Moment:10:2,AsM:9:2,Querkraft:13:2,
              '  ******************************')
  end;

begin
  clrscr;
  repeat
    Eingabe;
    Kontrolle:=[];
    Step:=Feldlaenge/Teilung;
    Nochnicht:=true;
    for I:=0 to Teilung+1 do
    begin
      Ort:=I*Step;
      if (Ort > OrtMaxMoment) and Nochnicht then
      begin
        Nochnicht:=false;
        I:=I-1;
        Ort:=OrtMaxMoment
      end;
      Schnittkraft(Ort,Moment,Querkraft);
      if Moment <= 0 then
      begin
        AsM:=0;
        VorhKz:=1
      end
      else
      begin
        BemessungM(Moment,VorhKs,VorhKz,Erfolg1);
        AsM:=VorhKs*Moment/StatHoehe;
        Kontrolle:=Kontrolle+[Erfolg1]
      end;
      BemessungQ(abs(Querkraft),VorhKz,MaxTau,Tau,Schubbereich,Erfolg2);
      AsQ:=1.4*MaxTau*Breite;
      Kontrolle:=Kontrolle+[Erfolg2];
      Ausdruck(Erfolg1,Erfolg2)
    end;
    if M in Kontrolle then
    begin
      normvideo;
      writeln('Bei  der Momentenbemessung ist ein Fehler  aufgetreten.');
      writeln('Die Materialwerte und / oder die Querschnittswerte sind');
      writeln('unterdimensioniert.                                    ');
      writeln('Bitte fuer eine erneute Berechnung neue Werte eingeben.')
    end;
    if Q in Kontrolle then
    begin
      normvideo;
      writeln('Bei der Querkraftbemessung ist ein Fehler  aufgetreten.');
      writeln('Die Materialwerte und / oder die Querschnittswerte sind');
      writeln('unterdimensioniert.                                    ');
      writeln('Bitte fuer eine erneute Berechnung neue Werte eingeben.')
    end;
    lowvideo
  until Kontrolle = [Ok]
end;

procedure Bemessung;
var
  Wahl :char;
begin
  writeln;
  writeln('Bemessung als :  S - Stahltraeger');
  writeln('                 B - Stahlbetontraeger');
  writeln('                 X - keine Bemessung');
  writeln;
  write('    Ihre Wahl :');
  repeat
    gotoxy(18,9); read(Wahl)
  until Wahl in ['s','S','b','B','x','X'];
  case Wahl of
    's','S' : StahlBemessung;
    'b','B' : BetonBemessung
  end
end;

procedure Ausgabe;
begin
  clrscr;
  writeln('Auflager A (links)  = ',Auflagerlinks:8:2,' kN');
  writeln('Auflager B (rechts) = ',Auflagerrechts:8:2,' kN');
  writeln('maximales Moment    = ',MaxMoment:8:2,' kNm  bei x = ',OrtMaxMoment:5:2,' m')
end;

