program BibMaker;
type
  Styp       =string[255];
  S2typ      =string[2];
  S7typ      =string[7];
  S8typ      =string[8];
  S14typ     =string[14];
  Generaltyp =record
    Steuerung               :(Manuell,Automatisch);
    Fc_name,Fi_name,Fo_name :S14typ;
    Fc,Fi,Fo                :text;
    C                       :char
  end;

var
  V :Generaltyp;

procedure Betriebsart_Ermittlung(var P :Generaltyp);
var
  Aufruf_Argument :S14typ absolute $80;

begin
  while pos(' ',Aufruf_Argument) = 1 do delete(Aufruf_Argument,1,1);
  if Aufruf_Argument = '' then
  begin
    repeat
      write('+++ Vorname der Bibliotheks-Datei: ');
      readln(P.Fo_name);
      if pos('.',P.Fo_name) > 0 then writeln(^G'--- Keine Nachnamen angeben. Immer "BIB".-');
    until (pos('.',P.Fo_name) = 0) and (P.Fo_name > '');
    P.Fo_name:=P.Fo_name+'.BIB';
    P.Steuerung:=Manuell
  end
  else
  begin
    P.Fo_name:=Aufruf_Argument;
    if pos('.',P.Fo_name) > 0 then
    begin
      writeln(^G'--- Keine Nachnamen angeben. Immer "BIB".');
      writeln('Programm wird abgebrochen.-');
      halt
    end;
    P.Fo_name:=P.Fo_name+'.BIB';
    P.Fc_name:='PSEND.CMF';
    P.Steuerung:=Automatisch
  end
end;

function Vorhanden(var Datei :text):boolean;
begin
  {$I-} reset(Datei) {$I+};
  Vorhanden:=IOResult = 0
end;

procedure Verpack_Gruppe(E :S8typ; var A :S7typ);
const
  Msb :byte =$80;
var
  M,N :byte;

begin
  M:=1; A:=copy(E,1,7);
  for N:=1 to 7 do
  begin
    if (byte(E[8]) and M) > 0 then A[N]:=char(byte(A[N]) or Msb);
    M:=M*2
  end
end;

procedure Verpack_Zeile(var E,A :Styp);
var
  S7 :S7typ; S8 :S8typ;

begin
  A:='';
  while length(E) > 7 do
  begin
    S8:=copy(E,1,8);
    delete(E,1,8);
    Verpack_Gruppe(S8,S7);
    A:=A+S7
  end;
  A:=A+E
end;

procedure Programm_Abbruch(Botschaft :Styp; var Fo :text);
begin
  writeln(^G'--- ',Botschaft,'.');
  writeln(^G'Programm wird abgebrochen, Ausgabedatei geloescht.-');
  close(Fo);
  erase(Fo);
  halt
end;

procedure Textdatei_Uebernehmen(var P :Generaltyp);
var
  S,SS :Styp; N :integer;

begin
  assign(P.Fi,P.Fi_name);
  if not Vorhanden(P.Fi) then Programm_Abbruch('Datei '+P.Fi_name+' nicht gefunden',P.Fo);
  if eof(P.Fi) then Programm_Abbruch('Datei '+P.Fi_name+' ist leer',P.Fo);
  S:=P.Fi_name; N:=pos(':',S);
  if N > 0 then delete(S,1,N);
  S:='$$$'+S;
  Verpack_Zeile(S,SS);
  writeln(P.Fo,SS);
  repeat
    readln(P.Fi,S);
    Verpack_Zeile(S,SS);
    writeln(P.Fo,SS)
  until eof(P.Fi);
  close(P.Fi);
  S:='              {-----------------------------------------------------}';
  Verpack_Zeile(S,SS);
  writeln(P.Fo,SS)
end;

procedure Manuelle_Durchfuehrung(var P :Generaltyp);
begin
  repeat
    write('+++ Welche Datei uebernehmen (<CR>: Abbruch): ');
    readln(P.Fi_name);
    if P.Fi_name > '' then
    begin
      assign(P.Fi,P.Fi_name);
      if not Vorhanden(V.Fi) then writeln(^G'--- Datei '+V.Fi_name+' nicht gefunden.-')
      else Textdatei_Uebernehmen(P)
    end
  until P.Fi_name = ''
end;

procedure Automatische_Durchfuehrung(var P :Generaltyp);
begin
  assign(P.Fc,P.Fc_name);
  if not Vorhanden(P.Fc) then
    Programm_Abbruch('Steuerdatei '+P.Fc_name+' nicht gefunden',P.Fo);
  repeat
    readln(P.Fc,P.Fi_name);
    writeln('+++ Uebertragen wird ',P.Fi_name);
    Textdatei_Uebernehmen(P)
  until eof(P.Fc)
end;

begin {BibMaker}
  clrscr;
  writeln('======================');
  writeln('BIBMaker (Wol/10-9-86)');
  writeln('======================');
  writeln('Erzeugung einer gepackten BIB-Datei aus Text-Dateien.'^M^J);
  Betriebsart_Ermittlung(V);
  assign(V.Fo,V.Fo_name);
  if Vorhanden(V.Fo) then
  repeat
    write('--- Datei ',V.Fo_name,' existiert. ');
    write('Ueberschreiben (J/N)? ');
    read(kbd,V.C); V.C:=upcase(V.C); writeln(V.C);
    if not (V.C in ['J','N']) then write(^G)
  until V.C in ['J','N'];
  if V.C = 'N' then halt;
  rewrite(V.Fo);
  if V.Steuerung = Automatisch then Automatische_Durchfuehrung(V)
  else Manuelle_Durchfuehrung(V);
  close(V.Fo);
  writeln('+++ Geschrieben wurde in Datei ',V.Fo_name,'.');
  writeln('+++ Programm BIBMaker beendet.-')
end.
