program Btree;
const
  N  = 2;
  NN = 4;
type
  Ref  = ^Page;
  Item = record
    Key   :integer;
    P     :Ref;
    Count :integer
  end;
  Page = record
    M  :0..NN;
    P0 :Ref;
    E  :array[1..NN] of Item
  end;
var
  Root,Q :Ref;
  X      :integer;
  H      :boolean;
  U      :Item;

{$A-}
procedure PrintTree(P :Ref; L :integer);
var
  I :integer;
begin
  if P <> nil then
    with P^ do
    begin
      for I:=1 to L do write('    ');
      for I:=1 to M do write(E[I].Key:4);
      writeln;
      PrintTree(P0,L+1);
      for I:=1 to M do PrintTree(E[I].P,L+1)
    end
end;

procedure Search(X :integer; A :Ref; var H :boolean; var V :Item);
var
  K,L,R :integer;
  Q     :Ref;
  U     :Item;

{$A+}
procedure Insertation;
var
  I :integer;
  B :Ref;
begin
  with A^ do
  begin
    if M < NN then
    begin
      M:=M+1;
      H:=false;
      for I:=M downto R+2 do E[I]:=E[I-1];
      E[R+1]:=U
    end
    else
    begin
      new(B);
      if R <= N then
      begin
        if R = N then V:=U
        else
        begin
          V:=E[N];
          for I:=N downto R+2 do E[I]:=E[I-1];
          E[R+1]:=U
        end;
        for I:=1 to N do B^.E[I]:=A^.E[I+N]
      end
      else
      begin
        R:=R-N;
        V:=E[N+1];
        for I:=1 to R-1 do B^.E[I]:=A^.E[I+N+1];
        B^.E[R]:=U;
        for I:=R+1 to N do B^.E[I]:=A^.E[I+N]
      end;
      M:=N;
      B^.M:=N;
      B^.P0:=V.P;
      V.P:=B
    end
  end
end;

{$A-}
begin
  if A = nil then
  begin
    H:=true;
    with V do
    begin
      Key:=X;
      Count:=1;
      P:=nil
    end
  end
  else
  with A^ do
  begin
    L:=1;
    R:=M;
    repeat
      K:=(L+R) div 2;
      if X <= E[K].Key then R:=K-1;
      if X >= E[K].Key then L:=K+1
    until R < L;
    if L-R > 1 then
    begin
      E[K].Count:=E[K].Count+1;
      H:=false
    end
    else
    begin
      if R = 0 then Q:=P0 else Q:=E[R].P;
      Search(X,Q,H,U);
      if H then Insertation
    end
  end
end;

procedure Deletation(X :integer; A :Ref; var H :boolean);
var
  I,K,L,R :integer;
  Q       :Ref;

{$A+}
procedure Underflow(C,A :Ref; S :integer; var H :boolean);
var
  I,K,Mb,Mc :integer;
  B         :Ref;
begin
  Mc:=C^.M;
  if S < Mc then
  begin
    S:=S+1;
    B:=C^.E[S].P;
    Mb:=B^.M;
    K:=(Mb-N+1) div 2;
    A^.E[N]:=C^.E[S];
    A^.E[N].P:=B^.P0;
    if K > 0 then
    begin
      for I:=1 to K-1 do A^.E[I+N]:=B^.E[I];
      C^.E[S]:=B^.E[K];
      C^.E[S].P:=B;
      B^.P0:=B^.E[K].P;
      Mb:=Mb-K;
      for I:=1 to Mb do B^.E[I]:=B^.E[I+K];
      B^.M:=Mb;
      A^.M:=N-1+K;
      H:=false
    end
    else
    begin
      for I:=1 to N do A^.E[I+N]:=B^.E[I];
      for I:=S to Mc-1 do C^.E[I]:=C^.E[I+1];
      A^.M:=NN;
      C^.M:=Mc-1
    end
  end
  else
  begin
    if S = 1 then B:=C^.P0 else B:=C^.E[S-1].P;
    Mb:=B^.M+1;
    K:=(Mb-N) div 2;
    if K > 0 then
    begin
      for I:=N-1 downto 1 do A^.E[I+K]:=A^.E[I];
      A^.E[K]:=C^.E[S];
      A^.E[K].P:=A^.P0;
      Mb:=Mb-K;
      for I:=K-1 downto 1 do A^.E[I]:=B^.E[I+Mb];
      A^.P0:=B^.E[Mb].P;
      C^.E[S]:=B^.E[Mb];
      C^.E[S].P:=A;
      B^.M:=Mb-1;
      A^.M:=N-1+K;
      H:=false
    end
    else
    begin
      B^.E[Mb]:=C^.E[S];
      B^.E[Mb].P:=A^.P0;
      for I:=1 to N-1 do B^.E[I+Mb]:=A^.E[I];
      B^.M:=NN;
      C^.M:=Mc-1
    end
  end
end;

{$A-}
procedure Del(P :Ref; var H :boolean);
var
  Q :Ref;
begin
  with P^ do
  begin
    Q:=E[M].P;
    if Q <> nil then
    begin
      Del(Q,H);
      if H then Underflow(P,Q,M,H)
    end
    else
    begin
      P^.E[M].P:=A^.E[K].P;
      A^.E[K]:=P^.E[M];
      M:=M-1;
      H:=M < N
    end
  end
end;

begin
  if A = nil then
  begin
    writeln('Key is not in tree');
    H:=false
  end
  else
  with A^ do
  begin
    L:=1; R:=M;
    repeat
      K:=(L+R) div 2;
      if X <= E[K].Key then R:=K-1;
      if X >= E[K].Key then L:=K+1
    until L > R;
    if R = 0 then Q:=P0 else Q:=E[R].P;
    if L-R > 1 then
    begin
      if Q = nil then
      begin
        for I:=K to M do E[I]:=E[I+1]
      end
      else
      begin
        Del(Q,H);
        if H then Underflow(A,Q,R,H)
      end
    end
    else
    begin
      Deletation(X,Q,H);
      if H then Underflow(A,Q,R,H)
    end
  end
end;

{$A+}
begin
  Root:=nil;
  read(X);
  while X <> 0 do
  begin
    writeln('Search key ',X);
    Search(X,Root,H,U);
    if H then
    begin
      Q:=Root;
      new(Root);
      with Root^ do
      begin
        M:=1;
        P0:=Q;
        E[1]:=U
      end
    end;
    PrintTree(Root,1);
    read(X)
  end;
  read(X);
  while X <> 0 do
  begin
    writeln('Delete key ',X);
    deletation(X,Root,H);
    if H then
    begin
      if Root^.M = 0 then
      begin
        Q:=Root;
        Root:=Q^.P0
      end
    end;
    PrintTree(Root,1);
    read(X)
  end
end.
