{$B-,V-,I-}

const
  MaxFelder  = 50;

type
  FeldStr    = string[10];
  DbFeld     = record
                 name : FeldStr;
                 typ  : char;
                 size : byte;
                 nk   : byte;
                 off  : integer
               end;
  DbStruktur = record
                 felder : integer;
                 feld   : array[1..MaxFelder] of DbFeld;
                 datei  : file;
                 j,m,t  : byte;
                 recs,
                 FPos   : integer;
                 hdsize,
                 rsize  : integer;
                 buff   : ^integer;
                 modi   : boolean
               end;

  DbPointer  = ^DbStruktur;
  PathStr    = string[79];
  NamStr     = string[80];
  BufStr     = string[255];
  A          = array[0..255] of byte;

var
  DbResult : integer;
  DbEOF    : boolean;
  Header   : record
               ID,j,m,t     : byte;
               recs         : integer;
               hdsize,rsize : integer;
               dummy        : array[1..20] of byte
             end;
  XFeld    : record
               name         : array[1..10] of char;
               dummy1       : byte;
               typ          : char;
               dummy2       : array[1..4] of byte;
               size,nk      : byte;
               dummy3       : array[1..14] of byte
             end;
  FeldNr   : integer;

procedure GetDate(var t,m,j:integer);
const
  PhysDay   = $FF17;
  PhysMonth = $FF18;
  PhysYear  = $FF1D;
type
  Dumtyp    = record
                Dat,hourmin : integer
              end;
var
  TimDum         : Dumtyp;
begin
  bdos($69,addr(TimDum));
  t:=((mem[PhysDay] and $f0)*10)+(mem[PhysDay] and $f);
  m:=mem[PhysMonth] shr 4;
  j:=mem[PhysYear]-144
end;

procedure FeldNummer(f:DbPointer; fname:NamStr);
var
  i : integer;
begin
  FeldNr:=1;
  while (FeldNr <= f^.felder) and (f^.feld[FeldNr].name <> fname) do FeldNr:=FeldNr+1;
  if FeldNr > f^.felder then DbResult:=-2 else DbResult:=0
end;

{ - Satzzeiger bewegen;  f : Dateizeiger   }
{ -                      p : neue Position }

procedure DbGo(f:DbPointer; p:integer);
begin
  with f^ do
    if (p > recs) or (p < 1) then DbResult:=-1
    else
    begin
      seek(datei,hdsize+(p-1)*rsize);
      blockread(datei,buff^,rsize);
      DbResult:=IOResult;
      FPos:=p
    end
end;

{ - Datei oeffnen;  f    : Dateizeiger    }
{ -                 name : Name der Datei }

procedure DbUse(f:DbPointer; name:NamStr);
var
  i,o : integer;
  l   : byte;
begin
  fillchar(f^,sizeof(f^),0);
  if pos('.',name) = 0 then name:=name+'.dbf';
  assign(f^.datei,name);
  reset(f^.datei);
  DbResult:=IOResult;
  if DbResult = 0 then
  begin
    with f^ do
    begin
      blockread(datei,Header,SizeOf(Header));
      j:=header.j; m:=header.m; t:=header.t;
      recs:=header.recs; rsize:=header.rsize;
      felder:=(header.hdsize-$21) div $20;
      hdsize:=header.hdsize+1;
      o:=0;
      for i:=1 to felder do
      begin
        blockread(datei,XFeld,SizeOf(XFeld));
        l:=1;
        while (l < 10) and (XFeld.name[l] <> #0) do l:=l+1;
        move(XFeld.name[1],feld[i].name[1],l-1);
        feld[i].name[0]:=chr(l-1);
        feld[i].typ:=XFeld.typ;
        feld[i].size:=XFeld.size;
        feld[i].nk:=XFeld.nk;
        feld[i].off:=o;
        o:=o+XFeld.size
      end;
      modi:=false;
      DbEOF:=recs = 0;
      getmem(buff,rsize);
      if not DbEOF then DbGo(f,1);
      FPos:=1
    end;
    DbResult:=IOResult
  end
end;

{ - Datei schliessen;  f : Dateizeiger }

procedure DbClose(f:DbPointer);
var
  ja,mo,ta : integer;
begin
  with f^ do
  begin
    if modi then
    begin
      seek(datei,0);
      blockread(datei,Header,SizeOf(Header));
      GetDate(ja,mo,ta);
      Header.j:=ja-1900; Header.m:=mo; Header.t:=ta;
      Header.recs:=recs;
      seek(datei,0);
      blockwrite(datei,header,SizeOf(Header))
    end;
    close(datei);
    freemem(buff,rsize)
  end;
  DbResult:=IOResult
end;

{ - Satzzeiger um 1 weiterbewegen;  f : Dateizeiger }

procedure DbSkip(f:DbPointer);
begin
  with f^ do
    if FPos >= recs then DbEOF:=true
    else
    begin
      FPos:=FPos+1;
      seek(datei,hdsize+(FPos-1)*rsize);
      blockread(datei,buff^,rsize)
    end;
  DbResult:=IOResult
end;

{ - Datensatz auslesen;  f     : Datenzeiger }
{ -                      fname : Feldname    }

function DbRead(f:DbPointer; fname:FeldStr):BufStr;
var
  h : BufStr;
begin
  with f^ do
    if FPos > recs then DbRead:=''
    else
    begin
      FeldNummer(f,fname);
      if DbResult < 0 then DbRead:=''
      else
      begin
        move(mem[buff^+feld[FeldNr].off],h[1],feld[FeldNr].size);
        h[0]:=chr(feld[FeldNr].size);
        DbRead:=h;
        DbResult:=0
      end
    end
end;

{ - Datensatz auslesen;  Rueckgabe im Turbo-Pascal-Format }
{ -   f     : Dateizeiger                                 }
{ -   fname : Feldname                                    }
{ -   xp    : Rueckgabe-Variable                          }

procedure DbReadT(f:DbPointer; fname:FeldStr; var xp; Size:integer);
var
  x         : A absolute xp;
  h         : BufStr;
  r         : real;
  res,count : integer;
begin
  h:=DbRead(f,fname);
  with f^ do
    if h <> '' then
      case feld[FeldNr].typ of
        'C' : begin
                while (h <> '') and (h[length(h)] = ' ') do
                  delete(h,length(h),1);
                for count:=1 to Size do x[count]:=mem[addr(h)+count]
              end;
        'N' : begin
                val(h,r,res);
                for count:=1 to Size do x[count]:=mem[addr(r)+count]
              end;
        'D' : begin
                h:=copy(h,7,2)+'.'+copy(h,5,2)+'.'+copy(h,1,4);
                for count:=1 to Size do x[count]:=mem[addr(h)+count]
              end;
        'L' : if (h = 'J') or (h = 'T') then
              begin
                x[1]:=$ff;
                x[2]:=$ff
              end
              else
              begin
                x[1]:=0;
                x[2]:=0
              end
      end
end;

{ - Datei anlegen;  f     : Dateizeiger }
{ -                 fname : Feldname    }

procedure DbCreate(f:DbPointer; name:NamStr);
var
  i,o      : integer;
  x        : array[1..2] of char;
  ta,mo,ja : integer;
begin
  if pos('.',name) = 0 then name:=name+'.dbf';
  assign(f^.datei,name);
  rewrite(f^.datei);
  DbResult:=IOResult;
  if DbResult = 0 then
  begin
    with f^ do
    begin
      fillchar(Header,sizeof(Header),0);
      Header.ID:=3;
      getdate(ja,mo,ta);
      Header.j:=ja-1900; Header.m:=mo; Header.t:=ta;
      Header.hdsize:=felder*$20+$21;
      rsize:=1;
      for i:=1 to felder do
      begin
        if feld[i].typ = 'D' then feld[i].size:=8;
        if feld[i].typ = 'L' then feld[i].size:=1;
        rsize:=rsize+feld[i].size
      end;
      Header.rsize:=rsize;
      blockwrite(datei,Header,SizeOf(Header));
      hdsize:=header.hdsize+1;
      o:=0;
      for i:=1 to felder do
      begin
        fillchar(XFeld,sizeof(XFeld),0);
        move(feld[i].name[1],XFeld.name,length(feld[i].name));
        XFeld.typ:=feld[i].typ;
        XFeld.size:=feld[i].size;
        if feld[i].typ = 'N' then XFeld.nk:=feld[i].nk;
        blockwrite(datei,XFeld,SizeOf(XFeld));
        feld[i].off:=o;
        o:=o+feld[i].size
      end;
      modi:=false;
      DbEOF:=true;
      getmem(buff,rsize);
      recs:=0; FPos:=1;
      x[1]:=^M; x[2]:=^Z;
      blockwrite(datei,x,2)
    end;
    DbResult:=IOResult
  end
end;

{ - leeren Satz anhaengen;  f : Dateizeiger }

procedure DbAppend(f:DbPointer);
begin
  with f^ do
  begin
    recs:=recs+1;
    fillchar(buff^,rsize,' ');
    mem[buff^+rsize]:=$1a;
    seek(datei,hdsize+(recs-1)*rsize-1);
    blockwrite(datei,buff^,rsize+1);
    FPos:=recs;
    modi:=true
  end;
  DbResult:=IOResult
end;

{ - Feld schreiben;  f     : Dateizeiger  }
{ -                  fname : Feldname     }
{ -                  s     : neuer Inhalt }

procedure DbReplace(f:DbPointer; fname:FeldStr; s:BufStr);
begin
  with f^ do
    if (FPos > recs) or (FPos < 1) then DbResult:=-3
    else
    begin
      FeldNummer(f,fname);
      if DbResult = 0 then
      begin
        fillchar(buff^,rsize,' ');
        move(s[1],buff^,length(copy(s,1,feld[FeldNr].size)));
        seek(datei,hdsize+(FPos-1)*rsize+feld[FeldNr].off);
        blockwrite(datei,buff^,feld[FeldNr].size);
        modi:=true;
        DbResult:=IOResult
      end
    end
end;

{ - Feld schreiben;  Uebergabe im Turbo-Pascal-Format }
{ -   f     : Dateizeiger                             }
{ -   fname : Feldname                                }
{ -   x     : zu schreibende Variable                 }

procedure DbReplT(f:DbPointer; fname:FeldStr; var xp; Size:integer);
var
  x     : A absolute xp;
  h     : BufStr;
  r     : real;
  count : integer;
begin
  FeldNummer(f,fname);
  if DbResult = 0 then
    with f^ do
    begin
      case feld[FeldNr].typ of
        'C' : for count:=1 to Size do mem[addr(h)+count]:=x[count];
        'N' : begin
                for count:=1 to Size do mem[addr(r)+count]:=x[count];
                str(r:feld[FeldNr].size:feld[FeldNr].nk,h)
              end;
        'D' : begin
                for count:=1 to Size do mem[addr(h)+count]:=x[count];
                h:=copy(h,7,4)+copy(h,4,2)+copy(h,1,2)
              end;
        'L' : if (x[1] = $ff) and (x[2] = $ff) then h:='T' else h:='F'
      end;
      DbReplace(f,fname,h)
    end
end;

procedure SetDelFlag(f:DbPointer; c:char);
begin
  with f^ do
  begin
    if (FPos < 1) or (FPos > recs) then exit;
    seek(datei,hdsize+(FPos-1)*rsize-1);
    blockwrite(datei,c,1);
    DbResult:=IOResult
  end
end;

{ - Satz loeschen;  f : Dateizeiger }

procedure DbDelete(f:DbPointer);
begin
  SetDelFlag(f,'*')
end;

{ - Satz wiederherstellen;  f : Dateizeiger }

procedure DbRecover(f:DbPointer);
begin
  SetDelFlag(f,' ')
end;

{ - ist Datensatz geloescht ?  f : Dateizeiger }

function DbDeleted(f:DbPointer):boolean;
var
  c : char;
begin
  with f^ do
    if (FPos < 1) or (FPos > recs) then DbDeleted:=false
    else
    begin
      seek(datei,hdsize+(FPos-1)*rsize-1);
      blockread(datei,c,1);
      DbResult:=IOResult;
      DbDeleted:=c = '*'
    end
end;
