program DCheck;
{$C-}
const
  Break   = #3;
  Inv     = #27#$29;
  Non_Inv = #27#$28;
  Retry   = 2;
  Autor   = 'by XXX';
  Adresse = 'YYY';

  Seldsk = 9;                {BIOS Funktionen}
  Settrk = 10;
  Setsec = 11;
  Setdma = 12;
  Sread  = 13;
  Swrite = 14;
  Sectrn = 16;

  Reset               = 13;  {BDOS Funktionen}
  Select_Disk         = 14;
  Close_File          = 16;
  Search_for_First    = 17;
  Return_Current_Disk = 25;
  Set_DMA             = 26;
  Get_Addr            = 31;
  Direct_Bios_Calls   = 50;

  Sec_per_hard_sec = 1;
type
  Blanks      = string[80];
  Dph_Type    = record
    Xlt,Nul1,Nul2,
    Nul3,Nul4           :integer;
    Nul5,Mf             :byte;
    Dpb,Csv,Alv         :integer
  end;
  Dpb_Type    = record
    Spt         :integer;
    Bsh,Blm,Exm :byte;
    Dsm,Drm     :integer;
    Al0,Al1     :byte;
    Cks,Off     :integer;
    Psh,Phm     :byte
  end;
  Fcb_8       = record
    Dr          :byte;
    Name        :array[1..8] of char;
    Ext         :array[1..3] of char;
    Ex,S1,S2,Rc :byte;
    D           :array[1..8] of integer
  end;
  Fcb_16      = record
    Dr          :byte;
    Name        :array[1..8] of char;
    Ext         :array[1..3] of char;
    Ex,S1,S2,Rc :byte;
    D           :array[1..16] of byte
  end;
var
  Max_Drv,Max_Trk,Max_Sec,
  Sec_per_Block,Dir_Offset,
  System_Offset,Log_in_Drv,
  Drv_Max,Trk_Max,Sec_Max,
  Drv,Drv_Before,
  Trk,Trk_Before,
  Sec,Physsec,
  Def_Sys_Sec,Def_Dir_Sec,
  Def_Data_Block            :byte;
  Trans_Table,Capac,K       :integer;
  T                         :char;
  H                         :array[0..127] of byte;
  Def_Blocks                :array[1..200] of integer;
  Fil                       :text;
  Max_Block,No_File_Found   :boolean;
  Memory                    :array[$8000..$FFFF] of byte absolute $8000;

procedure Header;
begin
  clrscr;
  writeln(Inv:10,'D I S K  -  C H E C K ',Non_Inv,Autor:40);
  writeln
end;

function Ubios(Fn,Pa,Pbc,Pde,Phl :integer):integer;
var
  Biospb :record
    Func,A   :byte;
    Bc,De,Hl :integer
  end;
  Result :integer;
begin
  with Biospb do
  begin
    Func:=Fn; A:=Pa;
    Bc:=Pbc; De:=Pde; Hl:=Phl
  end;
  Result:=0;
  case Fn of
    2,3,7,13..15,17..19,24 : Result:=bdos(50,addr(Biospb));
    9,16,20,22,25          : Result:=bdoshl(50,addr(Biospb))
  else bdos(50,addr(Biospb))
  end;
  Ubios:=Result
end;

procedure Ende;
begin
  bdos(Reset);
  bdos(Select_Disk,Log_in_Drv);
  gotoxy(1,20);
  delline; delline; delline; delline; delline;
  if T = Break then write('Break - Taste ',Inv,'^C',Non_Inv,'   ==> ');
  writeln('Programmende');
  writeln('Warmstart wurde ausgefuehrt');
  writeln('Betriebslaufwerk Drive ',chr($41+Log_in_Drv),':');
  halt
end;

procedure Menue_1;
begin
  Header;
  writeln('Dieses Programm testet eine Diskette auf defekte Sektoren.');
  writeln;
  Log_in_Drv:=bdos(Return_Current_Disk);
  bdos(Reset);
  write('Ihr Computer verfuegt ueber 7 Laufwerke');
  writeln;
  writeln;
  Max_Drv:=7;
  write('Geben Sie das zu testende Laufwerk ein (A');
  if Max_Drv > 1 then write(' - ',chr($40+Max_Drv));
  write(') : ');
  repeat
    read(kbd,T);
    T:=upcase(T)
  until T in [Break,'A'..chr($40+Max_Drv)];
  if T = Break then Ende;
  writeln(T);
  Drv:=ord(T)-$41
end;

procedure Write_Hex(Lb :byte);
const
  Hex_Values = '0123456789ABCDEF';
begin
  write(copy(Hex_Values,Lb div 16 + 1,1));
  write(copy(Hex_Values,Lb mod 16 + 1,1))
end;

procedure Write_Block(Li :integer);
begin
  if Max_Block then
  begin
    Write_Hex(hi(Li));
    write(' ')
  end;
  Write_Hex(lo(Li));
  write(' ')
end;

procedure Get_Parameters;
var
  Li :integer;

  procedure Read_Dph(var Lj);
  var
    Dph :Dph_Type absolute Lj;

    procedure Read_Dpb(var Lk);
    var
      Dpb :Dpb_Type absolute Lk;
      begin
        Max_Sec:=Dpb.Spt div (Dpb.Phm+1);
        Sec_per_Block:=((Dpb.Blm+1)*128) div (128 shl Dpb.Psh);
        System_Offset:=Dpb.Off;
        Dir_Offset:=(32*(Dpb.Drm+1)) div (128 shl Dpb.Psh);
        Capac:=Dpb.Dsm;
        Max_Block:=Capac > 255;
        Li:=(Capac+1)*Sec_per_Block;
        Max_Trk:=Li div Max_Sec;
        if Li mod Max_Sec <> 0 then Max_Trk:=Max_Trk+1;
        Max_Trk:=Max_Trk+System_Offset
      end;
  begin
    Trans_Table:=Dph.Xlt;
    Read_Dpb(Memory[Dph.Dpb])
  end;

begin
  write('Berechne Laufwerk - Parameter...');
  Li:=Ubios(Seldsk,0,Drv,0,0);
  Read_Dph(Memory[Li])
end;

function Sp(I :integer):Blanks;
var
  Lsp :Blanks;
begin
  Lsp:='';
  for I:=1 to I do Lsp:=Lsp+' ';
  Sp:=Lsp
end;

procedure Start_Up;
begin
  Header;
  Get_Parameters;
  Drv_Max:=Max_Drv-1;
  Trk_Max:=Max_Trk-1;
  Sec_Max:=Max_Sec-1;
  Drv_Before:=99;
  Trk:=0;
  Trk_Before:=99;
  Sec:=0;
  Def_Sys_Sec:=0;
  Def_Dir_Sec:=0;
  Def_Data_Block:=0;
  No_File_Found:=true;
  K:=Ubios(Setdma,0,addr(H),0,0)
end;

procedure Menue;
begin
  Header;
  writeln('Dieses Programm testet eine Diskette auf defekte Sektoren.');
  writeln;
  writeln('Dabei werden getestet : - die Systemspuren');
  writeln(Sp(24),'- die Directory - Sektoren');
  writeln(Sp(24),'- die Daten - Sektoren');
  writeln;
  writeln('Wenn dabei defekte Daten - Sektoren festgestellt werden, wird eine');
  write('Datei ',Inv,'/DEFEKT/.###',Non_Inv,' erzeugt, ');
  writeln('die diese Sektoren belegt, so dass');
  writeln('sie vom Computer nicht mehr benutzt werden koennen.');
  writeln;
  writeln;
  write('Die Daten des Laufwerks ',chr($41+Drv),':');
  write('  - ',Max_Trk:3,' Spuren');
  write(Sp(14),'- davon ',System_Offset:2,' Systemspur');
  if System_Offset <> 1 then writeln('en') else writeln;
  write('                            - ',Max_Sec:3,' Sektoren / Spur');
  writeln(Sp(5),'- ',Sec_per_Block:2,' Sektoren / Block');
  write(Sp(28),'- ',Dir_Offset:3,' Directory Sektoren');
  write('  - ');
  Write_Block(Capac+1);
  writeln('= ',Capac+1:3,' Bloecke');
  writeln;
  writeln;
  write('Durch Eingabe von ',Inv,'^C',Non_Inv,' kann das Programm ');
  writeln('jederzeit abgebrochen werden!');
  writeln;
  write('Legen Sie die zu testende Diskette in Laufwerk ',chr($41+Drv));
  write(': und druecken Sie eine Taste! ');
  read(kbd,T);
  if T = Break then Ende;
  Header;
  writeln('Programmstart');
  writeln
end;

procedure Set_Value;
begin
  if Drv <> Drv_Before then
  begin
    K:=Ubios(Seldsk,0,Drv,1,0);
    Trk_Before:=99;
    Drv_Before:=Drv
  end;
  if Trk <> Trk_Before then
  begin
    K:=Ubios(Settrk,0,Trk,0,0);
    Trk_Before:=Trk
  end;
  K:=Ubios(Setsec,0,Sec,0,0)        {Hier liegt noch ein Bock: Sektoruebersetzung}
end;

function Read_Sector :boolean;
var
  La,Li :byte;
begin
  Set_Value;
  if keypressed then
  begin
    read(kbd,T);
    if T = Break then Ende
  end;
  La:=Ubios(Sread,0,0,0,0);
  if La = 0 then Read_Sector:=true
  else
  begin
    Li:=Retry;
    while (Li <> 0) and (La <> 0 ) do
    begin
      La:=Ubios(Sread,0,0,0,0);
      Li:=Li-1
    end;
    if La = 0 then Read_Sector:=true else Read_Sector:=false
  end
end;

procedure System;
begin
  if System_Offset = 0 then writeln('Keine Systemspuren getestet')
  else
  begin
    writeln('Teste Systemspur          : ');
    writeln('Teste Systemsektor        : ');
    writeln('Defekte Systemsektoren    : ');
    for Trk:=0 to System_Offset-1 do
    begin
      gotoxy(30,5); write(Trk:2);
      for Sec:=1 to Sec_Max do
      begin
        gotoxy(30,6); write(Sec:2);
        gotoxy(30,7); write(Def_Sys_Sec:2);
        if not Read_Sector then Def_Sys_Sec:=Def_Sys_Sec+1
      end
    end
  end;
  gotoxy(34,7);
  if Def_Sys_Sec > 0 then writeln(Inv,'Neues System generieren!',Non_Inv)
end;

procedure Directory;
var
  Li :integer;
begin
  writeln;
  writeln('Teste Directoryspur       : ');
  writeln('Teste Directorysektor     : ');
  writeln('Defekte Directorysektoren : ');
  Trk:=System_Offset;
  Sec:=1;
  for Li:=1 to Dir_Offset do
  begin
    gotoxy(30,9); write(Trk:2);
    gotoxy(30,10); write(Sec:2);
    gotoxy(30,11); write(Def_Dir_Sec:2);
    if not Read_Sector then Def_Dir_Sec:=Def_Dir_Sec+1;
    Sec:=Sec+1;
    if Sec > Sec_Max then
    begin
      Sec:=1;
      Trk:=Trk+1
    end
  end;
  gotoxy(34,11);
  if Def_Dir_Sec > 0 then writeln(Inv,'Reparieren Sie die Directory!',Non_Inv)
end;

procedure Store_Def_Block;
var
  Block :integer;
begin
  Def_Data_Block:=Def_Data_Block+1;
  Block:=(Trk-System_Offset)*Max_Sec;
  Block:=Block+Sec;
  Block:=Block div Sec_per_Block;
  if Def_Data_Block = 1 then Def_Blocks[1]:=Block
  else
    if Def_Blocks[Def_Data_Block-1] <> Block then Def_Blocks[Def_Data_Block]:=Block
    else Def_Data_Block:=Def_Data_Block-1;
  gotoxy(30,15); write(Def_Data_Block:2)
end;

procedure Data;
var
  Li :integer;
begin
  writeln;
  writeln('Teste Datenspur           :');
  writeln('Teste Datensektor         :');
  writeln('Defekte Datenbloecke      : ');
  if Sec < Sec_Max then
  begin
    gotoxy(29,13); write(Trk:3);
    gotoxy(30,15); write(Def_Data_Block:2);
    for Sec:=Sec to Sec_Max do
    begin
      gotoxy(30,14); write(Sec:2);
      if not Read_Sector then Store_Def_Block
    end
  end;
  for Trk:=Trk+1 to Trk_Max do
  begin
    gotoxy(29,13); write(Trk:3);
    Sec:=1;
    repeat
      gotoxy(30,14); write(Sec:2);
      if not Read_Sector then Store_Def_Block;
      Sec:=Sec+Sec_Per_Hard_Sec
    until Sec >= Sec_Max
  end;
  gotoxy(34,15);
  if Def_Data_Block > 0 then
  begin
    writeln(Inv,'Reparieren Sie defekte Sektoren mit DISKHELP!',Non_Inv);
    writeln;
    write('Liste der defekten Bloecke :     ');
    for Li:=1 to Def_Data_Block do
    begin
      Write_Block(Def_Blocks[Li]);
      write('  ')
    end;
    writeln;
    writeln
  end
end;

function Dir_Search :integer;
var
  Fcb            :array[0..3] of Fcb_8 absolute H;
  Position,Li,Lk :integer;
begin
  Drv_Before:=99;
  Trk:=System_Offset;
  Sec:=0;
  Li:=0;
  Position:=$FF;
  repeat
    if Read_Sector then begin end;
    for Lk:=0 to 3 do
      if Fcb[Lk].Dr = 0 then
        if Fcb[Lk].Name = '/DEFEKT/' then
          if Fcb[Lk].Ext = '###' then Position:=Lk;
    Li:=Li+1;
    Sec:=Sec+1;
    if Sec = Sec_Max then
    begin
      Sec:=0;
      Trk:=Trk+1
    end
  until Position in [0..3];
  Dir_Search:=addr(Fcb[Position])
end;

procedure Set_8(var Lj);
var
  Fcb :Fcb_8 absolute Lj;
  Li  :integer;
begin
  Fcb.Ex:=(Def_Data_Block-1) div 8;
  Fcb.Rc:=((Def_Data_Block-1) mod 8)*16+15;
  for Li:=1 to Def_Data_Block do Fcb.D[Li]:=Def_Blocks[Li]
end;

procedure Set_16(var Lj);
var
  Fcb :Fcb_16 absolute Lj;
  Li  :integer;
begin
  Fcb.Ex:=(Def_Data_Block-1) div 8;
  Fcb.Rc:=((Def_Data_Block-1) mod 8)*16+15;
  for Li:=1 to Def_Data_Block do Fcb.D[Li]:=Def_Blocks[Li]
end;

procedure Make_File;
var
  B_P_D,Li :integer;
begin
  writeln('Erzeuge File mit defekten Bloecken : /DEFEKT/.###');
  B_P_D:=16;
  if Max_Block then B_P_D:=8;
  if Def_Data_Block > B_P_D then
  begin
    writeln('File wurde nicht erzeugt. Zu viele defekte Bloecke!');
    writeln('Werfen Sie die Diskette weg!!!')
  end
  else
  begin
    bdos(Reset);
    assign(Fil,chr($41+Drv)+':/DEFEKT/.###');
    rewrite(Fil);
    close(Fil);
    K:=Ubios(Setdma,0,addr(H),0,0);
    Li:=Dir_Search;
    if Max_Block then Set_8(Memory[Li]) else Set_16(Memory[Li]);
    K:=Ubios(Swrite,0,0,0,0);
    writeln('File erzeugt')
  end
end;

procedure Print_File(var Lj);
var
  Fcb :Fcb_8 absolute Lj;
begin
  No_File_Found:=false;
  write('Defektes File : ');
  writeln(Fcb.Name,'.',Fcb.Ext)
end;

function Check_8(var Lk):boolean;
var
  Fcb   :Fcb_8 absolute Lk;
  Li,Lj :integer;
begin
  Check_8:=false;
  for Li:=1 to 8 do
    for Lj:=1 to Def_Data_Block do
      if Def_Blocks[Lj] = Fcb.D[Li] then Check_8:=true
end;

function Check_16(var Lk):boolean;
var
  Fcb   :Fcb_16 absolute Lk;
  Li,Lj :integer;
begin
  Check_16:=false;
  for Li:=1 to 16 do
    for Lj:=1 to Def_Data_Block do
      if Def_Blocks[Lj] = Fcb.D[Li] then Check_16:=true
end;

procedure Def_Files;
var
  Fcb   :array[0..3] of Fcb_8 absolute H;
  Li,Lj :integer;
begin
  writeln;
  write(Inv,'Bitte druecken Sie eine Taste! ',Non_Inv);
  read(kbd,T);
  Header;
  writeln('Suche vorhandene Files mit defekten Bloecken.');
  writeln;
  Trk:=System_Offset;
  Sec:=0;
  Li:=0;
  repeat
    if Read_Sector then begin end;
    for Lj:=0 to 3 do
      if Fcb[Lj].Dr in [0..$F] then
        if Fcb[Lj].Name <> '/DEFEKT/' then
          if Max_Block then
            if Check_8(Memory[addr(Fcb[Lj])]) then Print_File(Memory[addr(Fcb[Lj])])
            else if Check_16(Memory[addr(Fcb[Lj])]) then Print_File(Memory[addr(Fcb[Lj])]);
    Li:=Li+1;
    Sec:=Sec+1;
    if Sec = Sec_Max then
    begin
      Sec:=0;
      Trk:=Trk+1
    end
  until Li = Dir_Offset;
  if No_File_Found then writeln('Gott sei Dank kein File zerstoert!')
end;

begin
  Menue_1;
  Start_Up;
  Menue;
  System;
  Directory;
  if Def_Dir_Sec = 0 then
  begin
    Data;
    if Def_Data_Block > 0 then
    begin
      Make_File;
      Def_Files
    end
    else
    begin
      bdos(Reset);
      assign(Fil,chr($41+Drv)+':/DEFEKT/.###');
      rewrite(Fil);
      close(Fil);
      erase(Fil)
    end
  end;
  Ende
end.
