program KnobelDateiVerwaltung;
const
  SpielerDateiName :string[10] = 'KNOBEL.DAT';
  MaxSpielerZahl               = 200;
type
  String30      = string[30];
  SpielerRecord = record
    Wert        :integer;
    SpielerName :String30
  end;
var
  SpielerDatei :file of SpielerRecord;
  Buffer       :array[1..MaxSpielerZahl] of SpielerRecord;
  EndIndex     :integer;
  Wahl         :char;
  New_Rec      :SpielerRecord;
  Del_Name     :String30;
  NeuDatei     :boolean;

function GetNum(PointOk :boolean):real;
type
  SetOfChar = set of char;
var
  OkSet       :SetOfChar;
  NumStrTemp  :String30;
  Len         :integer;
  Num         :real;
  Cha         :char;
  ExpOk,Good  :boolean;
begin
  OkSet:=['0'..'9']; NumStrTemp:='';
  if PointOk then ExpOk:=true else ExpOk:=false;
  repeat
    Len:=length(NumStrTemp);
    if PointOk then OkSet:=OkSet+['.'] else OkSet:=OkSet-['.'];
    if ExpOk then OkSet:=OkSet+['E'] else OkSet:=OkSet-['E'];
    if Len=0 then OkSet:=OkSet+['-']-[chr(8),' ']
    else OkSet:=OkSet+[chr(8),' ']-['-'];
    if pos('E',NumStrTemp)=Len then OkSet:=OkSet+['-'];
    if pos('E',NumStrTemp)=Len-1 then OkSet:=OkSet-['-'];
    repeat
      read(kbd,Cha); Cha:=upcase(Cha);
      if Cha=^M then Cha:=' ';
      if Cha=',' then Cha:='.';
      Good:=Cha in OkSet;
      if Good then write(Cha) else write(chr(7))
    until Good;
    if Cha='.' then PointOk:=false;
    if Cha='E' then
      begin
        ExpOk:=false;
        PointOk:=false
      end;
    if Cha in (OkSet+['-']-[chr(8),' ']) then
      NumStrTemp:=concat(NumStrTemp,Cha);
    if Cha=chr(8) then
      begin
        if pos('E',NumStrTemp)=Len then ExpOk:=true;
        if pos('.',NumStrTemp)=Len then PointOk:=true;
        write(' ',chr(8)); delete(NumStrTemp,Len,1)
      end
  until Cha=' ';
  val(NumStrTemp,Num,Len); GetNum:=Num
end;

procedure ReadReal(var Re :real);
begin
  Re:=GetNum(true)
end;

procedure ReadInteger(var Integ :integer);
var
  Re  :real;
begin
  repeat
    Re:=GetNum(false)
  until abs(Re) < 32767;
  Integ:=trunc(Re)
end;

procedure Open_Datei;
begin
  NeuDatei:=false;
  assign(SpielerDatei,SpielerDateiName);
  {$I-} reset(SpielerDatei) {$I+};
  if ioresult <> 0 then NeuDatei:=true
end;

function Read_Datei:integer;
var
  Index :integer;
begin
  Index:=1;
  while not eof(SpielerDatei) do
  begin
    read(SpielerDatei,Buffer[Index]);
    Index:=succ(Index)
  end;
  Read_Datei:=Index-1
end;

procedure Write_Datei;
var
  I :integer;
begin
  rewrite(SpielerDatei);
  for I:=1 to EndIndex do write(SpielerDatei,Buffer[I]);
  close(SpielerDatei)
end;

procedure Name_Eintragen(Spieler :SpielerRecord);
var
  PosIndex,I :integer;

  function Suche_Wert(Rec :SpielerRecord):integer;
  var
    Index :integer;
  begin
    Index:=1;
    while (Rec.Wert < Buffer[Index].Wert) and (Index <= EndIndex) do
      Index:=succ(Index);
    Suche_Wert:=Index
  end;

begin
  if EndIndex = 0 then PosIndex:=1
  else
  begin
    PosIndex:=Suche_Wert(Spieler);
    for I:=EndIndex downto PosIndex do Buffer[I+1]:=Buffer[I]
  end;
  Buffer[PosIndex]:=Spieler;
  NeuDatei:=true;
  EndIndex:=succ(EndIndex)
end;

procedure Name_Loeschen(Spieler :String30);
var
  PosIndex,I :integer;

  function Suche_Namen(Rec :String30):integer;
  var
    Index            :integer;
    SuchStrg,RecStrg :String30;
  begin
    Index:=1;
    RecStrg:='';
    for I:=1 to length(Rec) do
      RecStrg:=RecStrg+upcase(Rec[I]);
    while (SuchStrg <> RecStrg) and (Index <= EndIndex) do
    begin
      SuchStrg:='';
      with Buffer[Index] do
      begin
        for I:=1 to length(SpielerName) do
          SuchStrg:=SuchStrg+upcase(SpielerName[I])
      end;
      Index:=succ(Index)
    end;
    Suche_Namen:=Index-1
  end;

begin
  if EndIndex <> 0 then
  begin
    PosIndex:=Suche_Namen(Spieler);
    if PosIndex > Endindex then
    begin
      gotoxy(10,10);
      writeln('Namen nicht gefunden !'^G);
      delay(500)
    end
    else
    begin
      for I:=PosIndex to EndIndex do Buffer[I]:=Buffer[I+1];
      NeuDatei:=true;
      EndIndex:=pred(EndIndex)
    end
  end
  else
  begin
    clrscr;
    writeln('Datei leer !'^G);
    repeat until keypressed
  end
end;

procedure Header;
begin
  writeln('SpielerNr:        Schaetzwert:                    Spielername:');
  writeln
end;

procedure List_Datei;
var
  PageLine,I :integer;
begin
  PageLine:=1;
  clrscr;
  Header;
  if EndIndex <> 0 then
  begin
    for I:=1 to EndIndex do
    begin
      writeln(I:10,Buffer[I].Wert:20,Buffer[I].SpielerName:40);
      PageLine:=succ(PageLine);
      if PageLine = 21 then
      begin
        writeln;
        write('<RETURN>');
        repeat until keypressed;
        clrscr;
        Header
      end
    end
  end
  else writeln('Datei leer !'^G);
  repeat until keypressed
end;

procedure Print_Gewinner;
var
  Von,Bis,I :integer;
begin
  if EndIndex <> 0 then
  begin
    repeat
      clrscr;
      gotoxy(10,3);
      write('Ausdruck der Gewinner mit Spielernummer');
      gotoxy(10,5);
      write('von :'); ReadInteger(Von);
      gotoxy(10,7);
      write('bis :'); ReadInteger(Bis)
    until (Von >= 1) and (Bis <= EndIndex);
    for I:=Von to Bis do
      writeln(lst,I:10,Buffer[I].Wert:20,Buffer[I].SpielerName:40)
  end
  else
  begin
    clrscr;
    writeln('Datei leer !'^G);
    repeat until keypressed
  end
end;

procedure Menu;
var
  I :integer;
begin
  clrscr;
  for I:=1 to 79 do write('*');
  writeln;
  writeln('                 Knobel-Datei-Verwaltung    fuer    ',
                                       MaxSpielerZahl,' Spieler');
  for I:=1 to 79 do write('*');
  gotoxy(10,10); write('(1) Spieler eintragen');
  gotoxy(10,11); write('(2) Spieler loeschen');
  gotoxy(10,12); write('(3) Spieler auflisten');
  gotoxy(10,13); write('(4) Gewinner ausdrucken');
  gotoxy(10,14); write('(5) Ende');
  gotoxy(10,20); write('Waehlen :');
  repeat
    read(kbd,Wahl)
  until Wahl in ['1'..'5'];
  writeln(Wahl)
end;

begin
  Open_Datei;
  if not NeuDatei then EndIndex:=Read_Datei else EndIndex:=0;
  repeat
    Menu;
    case Wahl of
      '1' :begin
             clrscr;
             gotoxy(10,1);
             write(EndIndex+1,'. Eingabe');
             gotoxy(10,3);
             write('Schaetzwert :');
             ReadInteger(New_Rec.Wert);
             gotoxy(10,5);
             write('Spielername :');
             readln(New_Rec.SpielerName);
             Name_Eintragen(New_Rec)
           end;
      '2' :begin
             clrscr;
             gotoxy(10,3);
             write('Spielername :');
             readln(Del_Name);
             Name_Loeschen(Del_Name)
           end;
      '3' :List_Datei;
      '4' :Print_Gewinner
    end
  until Wahl = '5';
  if NeuDatei then Write_Datei
end.
