program GlasKugel;
type
  Txtfeldtyp = array[1..10,1..10] of boolean;
const
  I_ = true;
  FF = false;
  Textfeld :Txtfeldtyp =
    ((FF,FF,FF,FF,FF,FF,FF,FF,FF,FF),
     (FF,FF,FF,I_,I_,I_,I_,FF,FF,FF),
     (FF,FF,I_,FF,FF,FF,FF,I_,FF,FF),
     (FF,FF,FF,I_,FF,FF,I_,FF,FF,FF),
     (FF,FF,FF,FF,FF,FF,FF,I_,I_,FF),
     (FF,FF,FF,FF,FF,FF,I_,FF,FF,FF),
     (FF,FF,FF,I_,I_,I_,I_,I_,I_,FF),
     (FF,FF,I_,FF,FF,FF,I_,FF,FF,FF),
     (FF,FF,FF,FF,FF,FF,FF,FF,FF,FF),
     (FF,FF,FF,FF,FF,FF,FF,FF,FF,FF));
  Deg_to_Rad  = 0.017453295;
  MaxX        = 764;
  MaxY        = 556;
  Grip_Status = $C0;
  Grip_Data   = $C1;
type
  Vektor  = record
    X,Y,Z :real
  end;
  Bildrec = array[0..255] of byte;
var
  Oeffwkl_h,Oeffwkl_v,
  Sm_nv_lampe,
  V,W,X,Ma,Mb,Mc,
  A,B,C,D,E,F,P,Q,N,O,
  R,U,K,Y,G,H,I,L,M,
  Brechungsindex        :real;
  Farbe,
  X_max,Y_max,
  Y_abs,
  Kug_li,Kug_re,
  Sch_li,Sch_re,
  Kug_li_alt,Kug_re_alt :integer;
  Radius,Radius_1,Radius2,
  Brechungsindex2       :real;
  Av,Bv,Cv,Kugelmitte,
  Mv,Kamera,Nv,Lampe    :Vektor;
  XH,YH,XL,YL,
  Taste,Wahl            :char;
  Kugeltreffer,
  Kug_clip_li,
  Kug_clip_re,
  Kugmitte_unten,
  Kuganf_unten,
  Schatten              :boolean;
  Bild                  :file of Bildrec;
  Bildname              :string[14];
  Buffer                :Bildrec;
  GripReady,Bildsichern :boolean;

function Tan(Winkel :real):real;
begin
  Tan:=sin(Winkel)/cos(Winkel)
end;

function Sign(Arg :integer):integer;
begin
  if Arg = 0 then Sign:=0
  else if Arg < 0 then Sign:=-1
       else Sign:=1
end;

function Sqrt_sign(Arg,Sign :real):real;
begin
  if Sign = 0.0 then Sqrt_sign:=0.0
  else if Sign < 0.0 then Sqrt_sign:=-sqrt(Arg)
       else Sqrt_sign:=sqrt(Arg)
end;

function Limited_round(V :real):integer;
const
  Minint = -maxint;
begin
  if V > maxint then Limited_round:=maxint
  else if V < Minint then Limited_round:=Minint
       else if V < 0 then Limited_round:=trunc(V)-1
            else Limited_round:=trunc(V)
end;

function GetNum(PointOk :boolean):real;
type
  SetOfChar = set of char;
  String30  = string[30];
var
  OkSet       :SetOfChar;
  NumStrTemp  :String30;
  Len         :integer;
  Num         :real;
  Cha         :char;
  ExpOk,Good  :boolean;
begin
  OkSet:=['0'..'9']; NumStrTemp:='';
  if PointOk then ExpOk:=true else ExpOk:=false;
  repeat
    Len:=length(NumStrTemp);
    if PointOk then OkSet:=OkSet+['.'] else OkSet:=OkSet-['.'];
    if ExpOk then OkSet:=OkSet+['E'] else OkSet:=OkSet-['E'];
    if Len=0 then OkSet:=OkSet+['-']-[chr(8),' '] else OkSet:=OkSet+[chr(8),' ']-['-'];
    if pos('E',NumStrTemp)=Len then OkSet:=OkSet+['-'];
    if pos('E',NumStrTemp)=Len-1 then OkSet:=OkSet-['-'];
    repeat
      read(kbd,Cha); Cha:=upcase(Cha);
      if Cha=^M then Cha:=' ';
      if Cha=',' then Cha:='.';
      Good:=Cha in OkSet;
      if Good then write(Cha) else write(chr(7))
    until Good;
    if Cha='.' then PointOk:=false;
    if Cha='E' then
      begin
        ExpOk:=false;
        PointOk:=false
      end;
    if Cha in (OkSet+['-']-[chr(8),' ']) then NumStrTemp:=concat(NumStrTemp,Cha);
    if Cha=chr(8) then
      begin
        if pos('E',NumStrTemp)=Len then ExpOk:=true;
        if pos('.',NumStrTemp)=Len then PointOk:=true;
        write(' ',chr(8)); delete(NumStrTemp,Len,1)
      end
  until Cha=' ';
  val(NumStrTemp,Num,Len); GetNum:=Num
end;

procedure ReadReal(var Re :real);
begin
  Re:=GetNum(true)
end;

procedure ReadInteger(var Integ :integer);
var
  Re  :real;
begin
  repeat
    Re:=GetNum(false)
  until abs(Re) < 32767;
  Integ:=trunc(Re)
end;

procedure Put_Byte(Pixelgruppe :byte);
begin
  while not GripReady do GripReady:=(port[Grip_Status] and $40) <> 0;
  port[Grip_Data]:=Pixelgruppe;
  GripReady:=false
end;

function Get_Byte:byte;
begin
  while not GripReady do GripReady:=(port[Grip_Status] and $80) <> 0;
  Get_Byte:=port[Grip_Data];
  GripReady:=false
end;

procedure SetXY(XKoord,YKoord :integer);
var
  NXH,NXL,NYH,NYL :char;
begin
  YKoord:=556-YKoord;
  NYH:=chr(YKoord div 32+32); NYL:=chr(YKoord mod 32+96);
  NXH:=chr(XKoord div 32+32); NXL:=chr(XKoord mod 32+64);
  if YH = NYH then
    if YL = NYL then
      if XH = NXH then write(NXL)
      else write(NYL+NXH+NXL)
    else if XH = NXH then write(NYL+NXL)
         else write(NYL+NXH+NXL)
  else if (YL = NYL) and (XH = NXH) then write(NYH+NXL)
       else write(NYH+NYL+NXH+NXL);
  XH:=NXH; YH:=NYH; XL:=NXL; YL:=NYL
end;

procedure PutPixel(Px,Py,Farbe :integer);
begin
  write(#28);
  case Farbe of
    0 :write(#27'W ');
    1 :write(#27'W!');
    2 :write(#27'W"');
    else write(#27'W#')
  end;
  SetXY(Px,Py)
end;

procedure Line(Px1,Py1,Px2,Py2 :integer);
begin
  write(#27'W!');
  write(#29);
  SetXY(Px1,Py1);
  SetXY(Px2,Py2)
end;

procedure Makebild;
begin
  write('Zeichnung anschliessend abspeichern ? (J/N) : ');
  readln(Taste);
  Taste:=upcase(Taste);
  if Taste = 'J' then
  begin
    writeln;
    write('Bildname (*.PIX) = ');
    readln(Bildname);
    assign(Bild,Bildname);
    rewrite(Bild);
    Bildsichern:=true
  end
  else Bildsichern:=false
end;

procedure Speichere_Bild;
var
  I,J :integer;
begin
  GripReady:=false;
  write(#27#27'i'#0#0);
  write(#27#27'c8');
  for J:=1 to 512 do
  begin
    write(#27#27'g'#0#1);
    for I:=0 to 255 do Buffer[I]:=Get_Byte;
    write(Bild,Buffer)
  end;
  write(#27#27'c0')
end;

procedure Lade_Bild;
var
  I,J :integer;
begin
  GripReady:=false;
  write(#27#27'i'#0#0);
  write(#27#27'C8');
  for J:=1 to 512 do
  begin
    write(#27#27'f'#0#1);
    read(Bild,Buffer);
    for I:=0 to 255 do Put_Byte(Buffer[I])
  end;
  write(#27#27'C0')
end;

procedure SetGraphMode;
begin
  write(#27#27'W!??0');
  write(#27#27'W"?00');
  write(#27#27'W#00?');
  write(#12#27#27'X')
end;

procedure TextMode;
begin
  write(#27#12#27#27'A')
end;

procedure Menu;
begin
  clrscr;
  writeln('********************************************************************************');
  writeln('*                      Glaskugelgrafik-Programm                                *');
  writeln('********************************************************************************');
  writeln;
  writeln;
  writeln('            (1) Bild zeichnen');
  writeln('            (2) Bild laden');
  writeln('            (3) Ende');
  writeln;
  writeln;
  write('            Bitte waehlen : ')
end;

procedure Schattenlinie(Xa,Y,Xe :integer);
var
  Lauf :integer;
begin
  Farbe:=3;
  for Lauf:=Xa+X_max to Xe+X_max do
    if (Lauf and 1) = (Y and 1) then PutPixel(Lauf,Y,Farbe)
end;

function V3_square(var Vektor1 :Vektor):real;
begin
  with Vektor1 do V3_square:=sqr(X)+sqr(Y)+sqr(Z)
end;

procedure V3_add(var Vektor1,Vektor2,Ergebnis :Vektor);
begin
  with Ergebnis do
  begin
    X:=Vektor1.X+Vektor2.X;
    Y:=Vektor1.Y+Vektor2.Y;
    Z:=Vektor1.Z+Vektor2.Z
  end
end;

procedure V3_sub(var Vektor1,Vektor2,Ergebnis :Vektor);
begin
  with Ergebnis do
  begin
    X:=Vektor1.X-Vektor2.X;
    Y:=Vektor1.Y-Vektor2.Y;
    Z:=Vektor1.Z-Vektor2.Z
  end
end;

procedure V3_r_mult(var Vektor1 :Vektor; Faktor :real);
begin
  with Vektor1 do
  begin
    X:=X*Faktor;
    Y:=Y*Faktor;
    Z:=Z*Faktor
  end
end;

function V3_skalarmult(var Vektor1,Vektor2 :Vektor):real;
begin
  with Vektor1 do V3_skalarmult:=X*Vektor2.X+Y*Vektor2.Y+Z*Vektor2.Z
end;

procedure Muster(S :integer; X,Y :real);
var
  Xi,Yi :integer;
begin
  Farbe:=1;
  Xi:=Limited_round(X);
  Yi:=Limited_round(Y);
  if odd(Xi) = odd(Yi) then PutPixel(S+X_max,Y_abs,Farbe)
  else if Yi = 3 then
         if Xi = 0 then
           if Textfeld[trunc(X*10)+1,trunc((Y-3.0)*10)+1] then
             PutPixel(S+X_max,Y_abs,Farbe)
end;

procedure Kugelrand(Zeile :integer);
var
  Di,Temp1,Temp2,Kug_li_real,Kug_re_real :real;
begin
  Temp1:=D+C*Zeile;
  Di:=sqr(Temp1)-A*(Zeile*(Zeile*B+E)+F);
  if Di < 0.0 then Kugeltreffer:=false
  else
  begin
    Temp2:=Sqrt_sign(Di,A);
    Kug_li_real:=(Temp1-Temp2)/A;
    Kug_re_real:=(Temp1+Temp2)/A;
    Kug_clip_li:=Kug_li_real*Ma+Zeile*Mb+Mc <= 0.0;
    Kug_clip_re:=Kug_re_real*Ma+Zeile*Mb+Mc <= 0.0;
    Kug_li:=Limited_round(Kug_li_real);
    Kug_re:=Limited_round(Kug_re_real);
    if not (Kug_clip_li or Kug_clip_re) then
      if (Kug_li > X_max) or (Kug_re < -X_max) then Kugeltreffer:=false
      else
      begin
        if Kug_li < -X_max then
        begin
          Kug_li:=-X_max;
          Kug_clip_li:=true
        end;
        if Kug_re > X_max then
        begin
          Kug_re:=X_max;
          Kug_clip_re:=true
        end;
        Kugeltreffer:=true; Farbe:=2
      end
    else if not Kug_clip_li then
           if Kug_li < -X_max then Kugeltreffer:=false
           else
           begin
             Kug_clip_re:=Kug_li > X_max;
             if not Kug_clip_re then
             begin
               Kug_re:=Kug_li;
               Kug_li:=-X_max
             end
             else
             begin
               Kug_li:=-X_max;
               Kug_re:=X_max
             end;
             Kug_clip_li:=true;
             Kugeltreffer:=true; Farbe:=2
           end
         else if Kug_clip_re then Kugeltreffer:=false
              else
              begin
                Kug_clip_li:=Kug_re < -X_max;
                if not Kug_clip_li then
                begin
                  Kug_li:=Kug_re;
                  Kug_re:=X_max
                end
                else
                begin
                  Kug_li:=-X_max;
                  Kug_re:=X_max
                end;
                Kug_clip_re:=true;
                Kugeltreffer:=true; Farbe:=2
              end
  end
end;

procedure Schattenrand(Zeile :integer);
var
  Di,Temp1,Temp2,Sch_li_real,Sch_re_real :real;
begin
  Temp1:=Q+Zeile*P;
  Di:=sqr(Temp1)-N*(Zeile*(Zeile*O+R)+U);
  if Di < 0.0 then Schatten:=false
  else
  begin
    Temp2:=Sqrt_sign(Di,N);
    Sch_li_real:=(Temp1-Temp2)/N;
    Sch_re_real:=(Temp1+Temp2)/N;
    Kug_clip_li:=Sch_li_real*V+Zeile*W+X >= 0.0;
    Kug_clip_re:=Sch_re_real*V+Zeile*W+X >= 0.0;
    Sch_li:=Limited_round(Sch_li_real);
    Sch_re:=Limited_round(Sch_re_real);
    if not (Kug_clip_li or Kug_clip_re) then
    begin
      if (Sch_li > X_max) or (Sch_re < -X_max) then Schatten:=false
      else
      begin
        if Sch_li < -X_max then Sch_li:=-X_max;
        if Sch_re > X_max then Sch_re:=X_max;
        Schatten:=true; Farbe:=3
      end
    end
    else if not Kug_clip_li then
         begin
           Schatten:=Sch_li >= -X_max;
           if Schatten then
           begin
             if Sch_li > X_max then Sch_re:=X_max else Sch_re:=Sch_li;
             Sch_li:=-X_max; Farbe:=3
           end
         end
         else
         begin
           Schatten:=not Kug_clip_re;
           if not Kug_clip_re then
             if Sch_re > X_max then Schatten:=false
             else
             begin
               if Sch_re < -X_max then Sch_li:=-X_max else Sch_li:=Sch_re;
               Sch_re:=X_max; Farbe:=3
             end
         end
  end
end;

procedure Zeichnung;
var
  Zeile :integer;

  procedure Kugelinneres;
  label
    99;
  var
    S                                       :integer;
    Wurz_bruch,J,Sm_rv_bv,Temp1,Temp2,Temp3 :real;
    Pv,Rv,Zv                                :Vektor;
  begin
    for S:=Kug_li+1 to Kug_re-1 do
    begin
      Zv:=Bv;
      V3_r_mult(Zv,Zeile);
      V3_add(Zv,Cv,Zv);
      Zv.X:=Zv.X+S*Av.X;
      Zv.Y:=Zv.Y+S*Av.Y;
      Temp1:=V3_square(Zv);
      Temp2:=V3_skalarmult(Mv,Zv);
      J:=(Temp2-sqrt(sqr(Temp2)-Temp1*Y))/Temp1;
      Pv:=Zv;
      V3_r_mult(Pv,J);
      V3_add(Pv,Kamera,Pv);
      V3_sub(Kugelmitte,Pv,Rv);
      V3_r_mult(Zv,Radius/sqrt(Temp1));
      Sm_rv_bv:=V3_skalarmult(Rv,Zv)/Radius2;
      Temp3:=Brechungsindex2+sqr(Sm_rv_bv)-1.0;
      if Temp3 < 0.0 then
      begin
        V3_r_mult(Rv,2.0*Sm_rv_bv);
        V3_sub(Zv,Rv,Zv);
        Zv.Z:=1.0
      end
      else
      begin
        V3_sub(Rv,Zv,Zv);
        Wurz_bruch:=1.0/(sqrt(Temp3)-Sm_rv_bv+1.0);
        V3_r_mult(Zv,Wurz_bruch);
        V3_sub(Rv,Zv,Zv);
        V3_r_mult(Zv,2.0*V3_skalarmult(Rv,Zv)/sqr(Wurz_bruch*Brechungsindex*Radius));
        V3_add(Pv,Zv,Pv);
        V3_sub(Pv,Kugelmitte,Rv);
        V3_r_mult(Zv,Radius/sqrt(V3_square(Zv)));
        Sm_rv_bv:=V3_skalarmult(Rv,Zv)/Radius2;
        V3_sub(Rv,Zv,Zv);
        Temp3:=1.0/Brechungsindex2+sqr(Sm_rv_bv)-1.0;
        if Temp3 < 0.0 then goto 99;
        V3_r_mult(Zv,1.0/(sqrt(Temp3)-Sm_rv_bv+1.0));
        V3_sub(Rv,Zv,Zv)
      end;
      if Zv.Z < 0.0 then
      begin
        J:=-Pv.Z/Zv.Z;
        Pv.X:=Pv.X+J*Zv.X;
        Pv.Y:=Pv.Y+J*Zv.Y;
        if (Pv.X*Nv.X+Pv.Y*Nv.Y) < Sm_nv_lampe then Muster(S,Pv.X,Pv.Y)
        else if (Pv.X*(Pv.X*G+K)+Pv.Y*(Pv.Y*H+L)+Pv.X*Pv.Y*I+M) < 0.0 then
               Muster(S,Pv.X,Pv.Y)
             else Schattenlinie(S,Y_abs,S)
      end; 99:
    end
  end;

  procedure Ebene;
  var
    Px_k1,Px_k2,Py_k1,Py_k2,Temp :real;

    procedure Ebenenmuster(Von,Bis :real);
    var
      S :integer;
    begin
      for S:=round(Von) to round(Bis) do Muster(S,S*Px_k1+Px_k2,S*Py_k1+Py_k2)
    end;

  begin
    Temp:=Zeile*Bv.Z+Cv.Z;
    Px_k1:=-Kamera.Z*Av.X/Temp;
    Px_k2:=Kamera.X-Kamera.Z*(Zeile*Bv.X+Cv.X)/Temp;
    Py_k1:=-Kamera.Z*Av.Y/Temp;
    Py_k2:=Kamera.Y-Kamera.Z*(Zeile*Bv.Y+Cv.Y)/Temp;
    Schattenrand(Zeile);
    if not (Kugeltreffer or Schatten) then Ebenenmuster(-X_max,X_max)
    else
    begin
      if not Kugeltreffer then
      begin
        if Sch_li > -X_max then Ebenenmuster(-X_max,Sch_li-1);
        if Sch_re < X_max then Ebenenmuster(Sch_re+1,X_max);
        Schattenlinie(Sch_li,Y_abs,Sch_re)
      end
      else if not Schatten then
           begin
             if Kug_li > -X_max then Ebenenmuster(-X_max,Kug_li-1);
             if Kug_re < X_max then Ebenenmuster(Kug_re+1,X_max)
           end
           else if Sch_re < (Kug_li-1) then
                begin
                  if Sch_li > -X_max then Ebenenmuster(-X_max,Sch_li-1);
                  Ebenenmuster(Sch_re+1,Kug_li-1);
                  if Kug_re < X_max then Ebenenmuster(Kug_re+1,X_max);
                  Schattenlinie(Sch_li,Y_abs,Sch_re)
                end
                else if Sch_li > (Kug_re+1) then
                     begin
                       if Kug_li > -X_max then Ebenenmuster(-X_max,Kug_li-1);
                       Ebenenmuster(Kug_re+1,Sch_li-1);
                       if Sch_re < X_max then Ebenenmuster(Sch_re+1,X_max);
                       Schattenlinie(Sch_li,Y_abs,Sch_re)
                     end
                     else
                     begin
                       if Kug_li > Sch_li then
                       begin
                         if Sch_li > -X_max then Ebenenmuster(-X_max,Sch_li-1);
                         Schattenlinie(Sch_li,Y_abs,Kug_li)
                       end
                       else if Kug_li > -X_max then Ebenenmuster(-X_max,Kug_li-1);
                       if Sch_re > Kug_re then
                       begin
                         Schattenlinie(Kug_re,Y_abs,Sch_re);
                         if Sch_re < X_max then Ebenenmuster(Sch_re+1,X_max)
                       end
                       else if Kug_re < X_max then Ebenenmuster(Kug_re+1,X_max)
                     end
    end
  end;

begin
  Zeile:=-Y_max-1;
  write(#27#27'55'#27#12);
  write(#27#27'X'#27#27'54');
  Kugelrand(Zeile);
  Kugmitte_unten:=Kugeltreffer;
  Kuganf_unten:=not Kugeltreffer;
  for Zeile:=-Y_max to y_max do
  begin
    Y_abs:=Y_max-Zeile;
    Kug_li_alt:=Kug_li;
    Kug_re_alt:=Kug_re;
    Kugelrand(Zeile);
    if not Kugeltreffer then
    begin
      if Kugmitte_unten then Line(Kug_li_alt+X_max,Y_abs,Kug_re_alt+X_max,Y_abs)
    end
    else if Kuganf_unten then
         begin
           Line(Kug_li+X_max,Y_abs,Kug_re+X_max,Y_abs);
           Kuganf_unten:=false
         end
         else
         begin
           if (Kug_re-Kug_li) >= 2 then Kugelinneres;
           if Kug_li_alt <> Kug_li then
             Line(Kug_li_alt+Sign(Kug_li-Kug_li_alt)+X_max,Y_abs,Kug_li+X_max,Y_abs)
           else if not Kug_clip_li then PutPixel(Kug_li+X_max,Y_abs,Farbe);
           if Kug_re_alt <> Kug_re then
             Line(Kug_re_alt+Sign(Kug_re-Kug_re_alt)+X_max,Y_abs,Kug_re+X_max,Y_abs)
           else if not Kug_clip_re then PutPixel(Kug_re+X_max,Y_abs,Farbe)
         end;
         Kugmitte_unten:=Kugeltreffer;
         if Zeile < (-Cv.Z/Bv.Z) then Ebene
  end;
  write(#27#27'55');
  write(#27#27'53');
  repeat until keypressed;
  if Bildsichern then
  begin
    Speichere_Bild;
    close(Bild)
  end
end;

procedure Skizze;
var
  Akt_zeile,Y_horizont :integer;
begin
  Y_horizont:=round(-Cv.Z/Bv.Z);
  if Y_horizont < -Y_max then Y_horizont:=-Y_max
  else
  begin
    if Y_horizont > Y_max then Y_horizont:=Y_max
    else Line(0,Y_max-Y_horizont,MaxX,Y_max-Y_horizont);
    for Akt_zeile:=-Y_max to Y_horizont do
    begin
      Y_abs:=Y_max-Akt_zeile;
      Kugelrand(Akt_zeile);
      if Kugeltreffer then
      begin
        PutPixel(Kug_li+X_max,Y_abs,Farbe);
        PutPixel(Kug_re+X_max,Y_abs,Farbe)
      end;
      Schattenrand(Akt_zeile);
      if Schatten then
      begin
        PutPixel(Sch_li+X_max,Y_abs,Farbe);
        PutPixel(Sch_re+X_max,Y_abs,Farbe)
      end
    end
  end;
  for Akt_zeile:=Y_horizont to Y_max do
  begin
    Y_abs:=Y_max-Akt_zeile;
    Kugelrand(Akt_zeile);
    if Kugeltreffer then
    begin
      PutPixel(Kug_li+X_max,Y_abs,Farbe);
      PutPixel(Kug_re+X_max,Y_abs,Farbe)
    end
  end;
  repeat until keypressed
end;

procedure Hole_Parameter;
var
  Fehler :integer;

  procedure V3_Read(var Vektor :Vektor);
  begin
    with Vektor do
    begin
      ReadReal(X); write(' ');
      ReadReal(Y); write(' ');
      ReadReal(Z); writeln
    end
  end;

begin
  Farbe:=1;
  clrscr;
  X_max:=MaxX-(MaxX div 2+1);
  Y_max:=MaxY-(MaxY div 2+1);
  writeln('Die Kugelparameter:');
  write('Der Mittelpunkt (xyz): '); V3_Read(Kugelmitte);
  write('Der Radius ..........: '); ReadReal(Radius); writeln;
  Radius2:=sqr(Radius); Radius_1:=1.0/Radius; writeln;
  write('Koordinaten der Lampe  (xyz): '); V3_Read(Lampe);
  write('Koordinaten der Kamera (xyz): '); V3_Read(Kamera);
  write('Der Blickvektor (xyz) ......: '); V3_Read(Cv);
  write('Die Oeffnungswinkel (hv) ...: ');
  ReadReal(Oeffwkl_h); write(' '); ReadReal(Oeffwkl_v); writeln;
  write('Brechungsindex n ...........: ');
  ReadReal(Brechungsindex); writeln
end;

procedure Berechne_Programmkonstanten;
var
  T1,T2,T3,T4,T5,T6 :real;

  procedure Berechne_Pixelvektoren_av_bv;
  var
    Av_betrag,Bv_betrag :real;
  begin
    Oeffwkl_h:=Oeffwkl_h*Deg_to_Rad;
    Oeffwkl_v:=Oeffwkl_v*Deg_to_Rad;
    Av.X:=Cv.Y;
    Av.Y:=-Cv.X;
    Bv.X:=-Cv.X*Cv.Z;
    Bv.Y:=-Cv.Y*Cv.Z;
    Bv.Z:=sqr(Cv.Y)+sqr(Cv.X);
    Av_betrag:=sqrt(1.0+sqr(Cv.Z)/Bv.Z)/(MaxX div 2+1)*Tan(Oeffwkl_h);
    Av.X:=Av_betrag*Av.X;
    Av.Y:=Av_betrag*Av.Y;
    Bv_betrag:=1.0/sqrt(Bv.Z)/(MaxY div 2+1)*Tan(Oeffwkl_v);
    V3_r_mult(Bv,Bv_betrag)
  end;

begin
  Brechungsindex2:=sqr(Brechungsindex);
  Berechne_Pixelvektoren_av_bv;
  V3_sub(Kugelmitte,Lampe,Nv);
  Sm_nv_lampe:=V3_skalarmult(Nv,Lampe);
  T1:=V3_square(Nv)-Radius2;
  G:=Nv.X*Nv.X-T1;
  H:=Nv.Y*Nv.Y-T1;
  I:=2.0*Nv.X*Nv.Y;
  K:=2.0*(Lampe.X*T1-Sm_nv_lampe*Nv.X);
  L:=2.0*(Lampe.Y*T1-Sm_nv_lampe*Nv.Y);
  M:=sqr(Sm_nv_lampe)-T1*V3_square(Lampe);
  T1:=-Av.X*Kamera.Z;
  T2:=Bv.Z*Kamera.X-Bv.X*Kamera.Z;
  T3:=Cv.Z*Kamera.X-Cv.X*Kamera.Z;
  T4:=-Av.Y*Kamera.Z;
  T5:=Bv.Z*Kamera.Y-Bv.Y*Kamera.Z;
  T6:=Cv.Z*Kamera.Y-Cv.Y*Kamera.Z;
  N:=G*sqr(T1)+H*sqr(T4)+I*T1*T4;
  O:=G*sqr(T2)+H*sqr(T5)+I*T2*T5+K*T2*Bv.Z;
  P:=2.0*(G*T1*T2+H*T4*T5)+I*(T1*T5+T2*T4)+K*T1*Bv.Z;
  Q:=2.0*(G*T1*T3+H*T4*T6)+I*(T1*T6+T3*T4)+K*T1*Cv.Z;
  R:=2.0*(G*T2*T3+H*T5*T6)+I*(T2*T6+T3*T5)+K*(T2*Cv.Z+T3*Bv.Z);
  U:=G*sqr(T3)+H*sqr(T6)+I*T3*T6+K*T3*Cv.Z;
  O:=O+L*T5*Bv.Z+M*Bv.Z*Bv.Z;
  P:=P+L*T4*Bv.Z;
  Q:=Q+L*T4*Cv.Z;
  R:=R+L*(T5*Cv.Z+T6*Bv.Z)+M*Bv.Z*Cv.Z*2.0;
  U:=U+(L*T6+M*Cv.Z)*Cv.Z;
  P:=-0.5*P;
  Q:=-0.5*Q;
  V:=T1*Nv.X+T4*Nv.Y;
  W:=T1*Nv.X+T5*Nv.Y-Bv.Z*Sm_nv_lampe;
  X:=T3*Nv.X+T6*Nv.Y-Cv.Z*Sm_nv_lampe;
  V3_sub(Kugelmitte,Kamera,Mv);
  Ma:=Mv.X*Av.X+Mv.Y*Av.Y;
  Mb:=V3_skalarmult(Mv,Bv);
  Mc:=V3_skalarmult(Mv,Cv);
  Y:=V3_square(Mv)-Radius2;
  A:=Ma*Ma-Y*(sqr(Av.X)+sqr(Av.Y));
  B:=Mb*Mb-Y*V3_square(Bv);
  C:=-Ma*Mb;
  D:=-Ma*Mc;
  E:=2.0*Mb*Mc;
  F:=sqr(Mc)-Y*V3_square(Cv)
end;

procedure Zeichnen;
begin
  writeln;
  Makebild;
  SetGraphMode;
  Zeichnung;
  TextMode
end;

begin
  repeat
    Menu;
    repeat
      read(kbd,Wahl)
    until Wahl in ['1'..'3'];
    writeln(Wahl);
    case Wahl of
      '1' :begin
             Hole_Parameter;
             Berechne_Programmkonstanten;
             writeln;
             write('<S>kizze oder <Z>eichnung ? : ');
             readln(Taste);
             Taste:=upcase(Taste);
             if Taste = 'Z' then Zeichnen
             else
             begin
               SetGraphMode;
               Skizze;
               TextMode;
               write('Skizze gefaellt ! Zeichnung ? (J/N) : ');
               readln(Taste);
               Taste:=upcase(Taste);
               if Taste = 'J' then Zeichnen
             end
           end;
      '2' :begin
             clrscr;
             write('Bildname (*.PIX) = ');
             readln(Bildname);
             assign(Bild,Bildname);
             reset(Bild);
             SetGraphMode;
             Lade_Bild;
             repeat until keypressed;
             TextMode
           end
    end
  until Wahl = '3';
  clrscr
end.
