program Labyrinth;
type
  Brettyp = array[0..81,0..26] of byte;
var
  Brett,
  Hilfbrett    :Brettyp;
  Maxzeile,
  Maxspalte,
  Startspalte,
  Startzeile,
  Zielspalte,
  Zielzeile    :integer;
  Anz          :integer;
  Dummy        :boolean;

procedure Setbrett;
var
  I,J :integer;
begin
  for I:=0 to 81 do
    for J:=0 to 26 do Brett[I,J]:=1;
  Anz:=0
end;

procedure Outbrett;
var
  I,J :integer;
begin
  gotoxy(1,1);
  for I:=1 to Maxzeile do
  begin
    for J:=1 to Maxspalte do
    begin
      case Brett[J,I] of
        1   :write(#$7F);
        2   :write('o');
        4   :write('x');
        64  :write('s');
        128 :write('z')
        else write(' ')
      end
    end;
    writeln
  end
end;

procedure Read_lab;
var
  Dateivar    :text;
  Hilfsstring :string[82];
  I,J         :integer;
begin
  Setbrett;
  assign(Dateivar,'LAB.DAT');
  reset(Dateivar);
  J:=1;
  Maxspalte:=0;
  while not eof(Dateivar) do
  begin
    readln(Dateivar,Hilfsstring);
    if (length(Hilfsstring) > Maxspalte) then
      Maxspalte:=length(Hilfsstring);
    for I:=1 to length(Hilfsstring) do
    begin
      case Hilfsstring[I] of
        's' :begin
               Startspalte:=I;
               Startzeile:=J;
               Brett[I,J]:=64
             end;
        'z' :begin
               Zielspalte:=I;
               Zielzeile:=J;
               Brett[I,J]:=128
             end;
        'x' :Brett[I,J]:=1
        else Brett[I,J]:=0
      end
    end;
    J:=succ(J)
  end;
  Maxzeile:=J-1;
  close(Dateivar);
  clrscr;
  Outbrett;
  repeat until keypressed
end;

procedure Write_lab;
var
  Dateivar    :text;
  Hilfsstring :string[82];
  I,J         :integer;
begin
  assign(Dateivar,'LAB.DAT');
  rewrite(Dateivar);
  for I:=1 to 24 do
  begin
    Hilfsstring:='';
    for J:=1 to 79 do
    begin
      case Brett[J,I] of
        64  :Hilfsstring:=Hilfsstring+'s';
        128 :Hilfsstring:=Hilfsstring+'z';
        1   :Hilfsstring:=Hilfsstring+'x'
        else Hilfsstring:=Hilfsstring+' '
      end
    end;
    writeln(Dateivar,Hilfsstring)
  end;
  close(Dateivar)
end;

{$A-}

procedure Make_lab(Spalte,Zeile,Richtung :integer);
var
  A,I,Ri :integer;
  R      :array[0..2] of byte;
begin
  A:=0;
  R[0]:=8;
  for I:=0 to 1 do R[I+1]:=R[I]+8;
  if Richtung > 2 then for I:=Richtung downto 2 do R[I]:=R[I]+48
  else for I:=Richtung to 2 do R[I]:=R[I]+48;
  repeat
    Ri:=random(80);
    if (Ri <= R[0]) and (Spalte > 2)
    and (Brett[Spalte-1,Zeile] = 1)
    and (Brett[Spalte-2,Zeile] = 1)
    and (Brett[Spalte-1,Zeile+1] = 1)
    and (Brett[Spalte-1,Zeile-1] = 1) then
    begin
      Brett[Spalte,Zeile]:=0;
      gotoxy(Spalte,Zeile);
      write(' ');
      Make_lab(Spalte-1,Zeile,0)
    end;
    if (Ri > R[0]) and (Ri <= R[1]) and (Spalte < 78)
    and (Brett[Spalte+1,Zeile] = 1)
    and (Brett[Spalte+2,Zeile] = 1)
    and (Brett[Spalte+1,Zeile+1] = 1)
    and (Brett[Spalte+1,Zeile-1] = 1) then
    begin
      Brett[Spalte,Zeile]:=0;
      gotoxy(Spalte,Zeile);
      write(' ');
      Make_lab(Spalte+1,Zeile,1)
    end;
    if (Ri > R[1]) and (Ri <= R[2]) and (Zeile > 2)
    and (Brett[Spalte,Zeile-1] = 1)
    and (Brett[Spalte,Zeile-2] = 1)
    and (Brett[Spalte+1,Zeile-1] = 1)
    and (Brett[Spalte-1,Zeile-1] = 1) then
    begin
      Brett[Spalte,Zeile]:=0;
      gotoxy(Spalte,Zeile);
      write(' ');
      Make_lab(Spalte,Zeile-1,2)
    end;
    if (Ri > R[2]) and (Zeile < 23)
    and (Brett[Spalte,Zeile+1] = 1)
    and (Brett[Spalte,Zeile+2] = 1)
    and (Brett[Spalte+1,Zeile+1] = 1)
    and (Brett[Spalte-1,Zeile+1] = 1) then
    begin
      Brett[Spalte,Zeile]:=0;
      gotoxy(Spalte,Zeile);
      write(' ');
      Make_lab(Spalte,Zeile+1,3)
    end;
    A:=succ(A)
  until (A = 10)
end;

procedure Floodfill(S,Z :integer);
begin
  Brett[S,Z]:=4;
  gotoxy(S,Z);
  write('x');
  if (Brett[S+1,Z] <> 2) and (Brett[S+1,Z] <> 4) and (S < 78) then
    Floodfill(S+1,Z);
  if (Brett[S-1,Z] <> 2) and (Brett[S-1,Z] <> 4) and (S > 2) then
    Floodfill(S-1,Z);
  if (Brett[S,Z+1] <> 2) and (Brett[S,Z+1] <> 4) and (Z < 23) then
    Floodfill(S,Z+1);
  if (Brett[S,Z-1] <> 2) and (Brett[S,Z-1] <> 4) and (Z > 2) then
    Floodfill(S,Z-1)
end;

function Floodcheck(S,Z :integer):boolean;
var
  Found :boolean;
begin
  Found:=false;
  if (Brett[S,Z] = 128) then Found:=true;
  Brett[S,Z]:=Brett[S,Z] or 16;
  if not Found
    and (Brett[S+1,Z] <> 2)
    and (Brett[S+1,Z] and 16 <> 16)
    and (S < 78) then Found:=Floodcheck(S+1,Z);
  if not Found
    and (Brett[S-1,Z] <> 2)
    and (Brett[S-1,Z] and 16 <> 16)
    and (S > 2) then Found:=Floodcheck(S-1,Z);
  if not Found
    and (Brett[S,Z+1] <> 2)
    and (Brett[S,Z+1] and 16 <> 16)
    and (Z < 23) then Found:=Floodcheck(S,Z+1);
  if not Found
    and (Brett[S,Z-1] <> 2)
    and (Brett[S,Z-1] and 16 <> 16)
    and (S > 2) then Found:=Floodcheck(S,Z-1);
  Floodcheck:=Found
end;

function Checkziel(S,Z :integer):boolean;
var
  I,J :integer;
begin
  Checkziel:=Floodcheck(S,Z);
  for I:=0 to 81 do
    for J:=0 to 26 do Brett[I,J]:=Brett[I,J] and 239
end;

function Find_way(Spalte,Zeile,Way :integer):boolean;
var
  Found     :boolean;
  R         :array[0..3] of integer;
  I,Dix,Diy :integer;
begin
  delay(30);
  for I:=0 to 3 do R[I]:=I;
  Diy:=Zielzeile-Zeile;
  Dix:=Zielspalte-Spalte;
  if (Dix < 0) then
  begin
    R[0]:=2;
    R[2]:=0
  end;
  if (Diy < 0) then
  begin
    R[1]:=3;
    R[3]:=1
  end;
  if (abs(Dix) < abs(Diy)) then
  begin
    I:=R[0];
    R[0]:=R[1];
    R[1]:=I;
    I:=R[2];
    R[2]:=R[3];
    R[3]:=I
  end;
  Anz:=succ(Anz);
  Found:=false;
  if (Brett[Spalte,Zeile] and 128 = 128) then Found:=true
  else
  begin
    I:=0;
    repeat
      if (R[I] = 0)
      and not Found
      and (((Brett[Spalte+1,Zeile] = 2) and (Way <> 2))
      or ((Brett[Spalte+1,Zeile] and 63) = 0)) then
      begin
        Brett[Spalte,Zeile]:=2;
        if (Brett[Spalte+1,Zeile] = 2) then
        begin
          if not Checkziel(Spalte,Zeile+1) then
            Floodfill(Spalte,Zeile+1)
          else if not Checkziel(Spalte,Zeile-1) then
                 Floodfill(Spalte,Zeile-1)
        end
        else
        begin
          gotoxy(Spalte,Zeile);
          write('o');
          Found:=Find_way(Spalte+1,Zeile,0);
          delay(30);
          gotoxy(Spalte+1,Zeile);
          write(' ')
        end
      end;
      if (R[I] = 1)
      and not Found
      and (((Brett[Spalte,Zeile+1] = 2) and (Way <> 3))
      or ((Brett[Spalte,Zeile+1] and 63) = 0)) then
      begin
        Brett[Spalte,Zeile]:=2;
        if (Brett[Spalte,Zeile+1] = 2) then
        begin
          if not Checkziel(Spalte+1,Zeile) then
            Floodfill(Spalte+1,Zeile)
          else if not Checkziel(Spalte-1,Zeile) then
                 Floodfill(Spalte-1,Zeile)
        end
        else
        begin
          gotoxy(Spalte,Zeile);
          write('o');
          Found:=Find_way(Spalte,Zeile+1,1);
          delay(30);
          gotoxy(Spalte,Zeile+1);
          write(' ')
        end
      end;
      if (R[I] = 2)
      and not Found
      and (((Brett[Spalte-1,Zeile] = 2) and (Way <> 0))
      or ((Brett[Spalte-1,Zeile] and 63) = 0)) then
      begin
        Brett[Spalte,Zeile]:=2;
        if (Brett[Spalte-1,Zeile] = 2) then
        begin
          if not Checkziel(Spalte,Zeile+1) then
            Floodfill(Spalte,Zeile+1)
          else if not Checkziel(Spalte,Zeile-1) then
                 Floodfill(Spalte,Zeile-1)
        end
        else
        begin
          gotoxy(Spalte,Zeile);
          write('o');
          Found:=Find_way(Spalte-1,Zeile,2);
          delay(30);
          gotoxy(Spalte-1,Zeile);
          write(' ')
        end
      end;
      if (R[I] = 3)
      and not Found
      and (((Brett[Spalte,Zeile-1] = 2) and (Way <> 1))
      or ((Brett[Spalte,Zeile-1] and 63) = 0)) then
      begin
        Brett[Spalte,Zeile]:=2;
        if (Brett[Spalte,Zeile-1] = 2) then
        begin
          if not Checkziel(Spalte+1,Zeile) then
            Floodfill(Spalte+1,Zeile)
          else if not Checkziel(Spalte-1,Zeile) then
                 Floodfill(Spalte-1,Zeile)
        end
        else
        begin
          gotoxy(Spalte,Zeile);
          write('o');
          Found:=Find_way(Spalte,Zeile-1,3);
          delay(30);
          gotoxy(Spalte,Zeile-1);
          write(' ')
        end
      end;
      I:=succ(I)
    until (I = 4)
  end;
  Find_way:=Found
end;

{$A+}

procedure Create_lab;
var
  I,Spalte,Zeile :integer;
begin
  clrscr;
  Maxzeile:=24;
  Maxspalte:=79;
  Setbrett;
  Outbrett;
  Make_lab(5,5,0);
  for I:=0 to 40 do
  begin
    Spalte:=2+random(77);
    Zeile:=2+random(22);
    Brett[Spalte,Zeile]:=0
  end;
  Startspalte:=5;
  Startzeile:=5;
  Brett[5,5]:=64;
  repeat
    Zielspalte:=32+random(47);
    Zielzeile:=12+random(12);
    if (Brett[Zielspalte,Zielzeile] <> 1) then
      Brett[Zielspalte,Zielzeile]:=128
    else
    begin
      Zielspalte:=0;
      Zielzeile:=0
    end
  until (Zielspalte+Zielzeile <> 0);
  Outbrett;
  repeat until keypressed
end;

procedure Menue;
var
  K :char;
begin
  repeat
    clrscr;
    gotoxy(1,6);
    writeln('++ 1 ++ Labyrinth erzeugen');
    writeln;
    writeln('++ 2 ++ Labyrinth einlesen');
    writeln;
    writeln('++ 3 ++ Labyrinth abspeichern');
    writeln;
    writeln('++ 4 ++ Labyrinth erforschen');
    writeln;
    writeln('++ 5 ++ Ende');
    readln(K);
    if (K = '1') then Create_lab;
    if (K = '2') then Read_lab;
    if (K = '3') then Write_lab;
    if (K = '4') then
    begin
      clrscr;
      Outbrett;
      Hilfbrett:=Brett;
      Anz:=0;
      if not Find_way(Startspalte,Startzeile,0) then
      begin
        gotoxy(1,1);
        write(#7,Anz:10,' (Rekursionsaufrufe) fuehrten nicht zum Ziel (keine Loesung)')
      end
      else
      begin
        gotoxy(1,1);
        write(Anz:10,' Schritte (Rekursionsaufrufe) fuehrten  zum Ziel')
      end;
      Brett:=Hilfbrett;
      repeat until keypressed
    end
  until (K = '5')
end;

begin
  Setbrett;
  Maxzeile:=24;
  Maxspalte:=79;
  Startspalte:=5;
  Startzeile:=5;
  Menue
end.
