{$C+}
program Memmap;
const
  WorkStrngLen                = 255;
  ProcessEnvironment :boolean = true;
  ProcessVectors     :boolean = true;
  ProcessPSPInfo     :boolean = true;
type
  Wrkstrng                = string[WorkStrngLen];
  Pointer                 = ^Pointer;
  PtrWorkPointer          = ^WorkPointer;
  PtrMemoryControlBlock   = ^MemoryControlBlock;
  MemoryControlBlock      = record
    Id  :char;
    Psp :integer;
    Len :integer
  end;
  PtrDosParameterBlock    = ^DosParameterBlock;
  DosParameterBlock       = record
    Drvnr :byte;
    Drvsu :byte;
    Bps   :integer;
    Bpss  :byte;
    Spc   :byte;
    Sr    :integer;
    Fats  :byte;
    Rdes  :integer;
    Fas   :integer;
    Las   :integer;
    Spf   :byte;
    Fds   :integer;
    Pdd   :Pointer;
    Mb    :byte;
    Usd   :boolean;
    Link  :Pointer
  end;
  PtrBufferHeader         = ^BufferHeader;
  BufferHeader            = record
    Link :Pointer;
    Drv  :byte;
    Uid  :byte;
    Sec  :integer;
    O8   :byte;
    O9   :byte;
    Pdpb :Pointer
  end;
  PtrProgramSegmentPrefix = ^ProgramSegmentPrefix;
  ProgramSegmentPrefix    = record
    Quit  :integer;
    Size  :integer;
    O4    :byte;
    O5    :byte;
    Fkdsp :Pointer;
    Terma :Pointer;
    Ctrlc :Pointer;
    Hrder :Pointer;
    Ldr   :integer;
    Ft    :array[0..19] of byte;
    Env   :integer
  end;
  PtrDriveNames           = ^DriveNames;
  DriveNames              = array[0..24] of record
    Drn :array[0..63] of char;
    U2  :Pointer;
    U3  :byte;
    Pdd :Pointer;
    Clu :integer;
    U4  :Pointer;
    Id  :byte;
    U5  :byte
  end;
  PtrDosInfoBlock         = ^DosInfoBlock;
  DosInfoBlock            = record
    Pfab   :PtrWorkPointer;
    Pdpb   :PtrWorkPointer;
    Plb    :Pointer;
    Pddrv1 :PtrWorkPointer;
    Pddrv2 :PtrWorkPointer;
    Maxsec :integer;
    Pbuf   :PtrWorkPointer;
    Prt    :PtrWorkPointer;
    Pft    :PtrWorkPointer
  end;
  PtrDeviceDriver         = ^DeviceDriver;
  DeviceDriver            = record
    Link  :Pointer;
    Attr  :integer;
    Strat :integer;
    Intr  :integer;
    case integer of
      1 :(Nam :array[0..7] of char);
      2 :(Num :byte)
  end;
  WorkPointer             = record
    case integer of
       1 :(P   :^Pointer);
       2 :(B   :^byte);
       3 :(I   :^integer);
       4 :(O,S :integer);
       5 :(C   :^char);
       6 :(DS  :PtrDosInfoBlock);
       7 :(MH  :PtrMemoryControlBlock);
       8 :(DP  :PtrDosParameterBlock);
       9 :(BH  :PtrBufferHeader);
      10 :(PP  :PtrProgramSegmentPrefix);
      11 :(WP  :PtrWorkPointer);
      12 :(DN  :PtrDriveNames);
      13 :(DD  :PtrDeviceDriver)
  end;
var
  Dosinfo  :WorkPointer;
  Endchain :WorkPointer;
  Vecarry  :array[0..255] of WorkPointer absolute $0:$0;

{$IMAP.IN0}
{$IMAP.IN1}

procedure HeadLine(Tittle :WrkStrng);
var
  L :byte;
begin
  writeln;
  for L:=0 to 79 do write('=');
  writeln(Tittle);
  for L:=0 to 79 do write('=');
  writeln
end;

function DoAbort:boolean;
var
  Ch :char;
begin
  writeln;
  write('Weiter mit beliebiger Taste... ');
  read(kbd,Ch);
  if Ch = #27 then DoAbort:=true else DoAbort:=false;
  write(#13);
  clreol
end;

procedure InitDosInfo;
var
  P :WorkPointer;
begin
  inline(
  $B8/$00/$52/     {MOV   AX,52h        }
  $CD/$21/         {INT   21h           }
  $8C/$86/P+2/     {MOV   [BP+P.S],ES   }
  $83/$EB/$04/     {SUB   BX,4          }
  $89/$9E/P);      {MOV   [BP+P.O],BX   }
  Dosinfo.P:=P.P;
  Endchain.S:=-1;
  Endchain.O:=-1
end;

procedure ShowDosInfo;
begin
  HeadLine('DOS-Info-Block auf Adresse:'+w(DH,Dosinfo.P));
  with Dosinfo.DS^ do
  begin
    writeln('Erster Memory-Control-Block  ',W(DH,Pfab):10);
    writeln('Erster DOS-Parameter-Block   ',W(DH,Pdpb):10);
    writeln('Letzter Puffer               ',W(DH,Plb):10);
    writeln('Clock-Device                 ',W(DH,Pddrv1):10);
    writeln('Console-Device               ',W(DH,Pddrv2):10);
    writeln('Maximale Sektorlaenge        ',W(UI,Maxsec):10,' Bytes');
    writeln('.............................................');
    writeln('Puffer                       ',W(DH,Pbuf):10);
    writeln('Redirector-Tabelle           ',W(DH,Prt):10);
    writeln('File-Table                   ',W(DH,Pft):10)
  end
end;

procedure ShowDosParameterBlocks;
label
  Exit;
var
  P,N :WorkPointer;
begin
  HeadLine('Die Parameter der Block-Devices');
  P.WP:=Dosinfo.DS^.Pdpb;
  N.WP:=Dosinfo.DS^.Prt;
  repeat
    with P.DP^ do
    begin
      writeln('Adresse dieses DPB: ',W(DH,P.P):20);
      write('Drive-Unit: ',Drvnr,'; Drive-Subunit: ',Drvsu,'; ');
      writeln('Pfadname: ',W(SZ,N.DN^[Drvnr].Drn));
      write(Bps,' Bytes pro Sektor; ',1 shl Spc,' Sektoren pro Cluster; ');
      writeln(Sr,' Sektoren reserviert;');
      write(Fats,' FATs ',Rdes,' Root-Dir-Entries; ');
      writeln('Erster Sektor: ',Fas,'; Letzter Cluster: ',Las);
      writeln(Spf,' Sektoren pro FAT; Datenbereich ab Sektor: ',W(UI,Fds));
      write('Device-Driver-Adresse: ',W(DH,Pdd),' Media-Byte: ',W(BH,Mb));
      case Mb of
        $FF :write(' Diskette D-8 ');
        $FE :write(' Diskette S-8 ');
        $FD :write(' Diskette D-9 ');
        $FC :write(' Diskette S-9 ');
        $F9 :write(' Diskette QD ');
        $F8 :write(' Festplatte ')
      end;
      write(' [');
      if Usd then write('un');
      writeln('benutzt]');
      writeln('DPB Link: ',W(DH,Link));
      writeln;
      P.P:=Link
    end;
    if DoAbort then goto Exit
  until (P.P = Endchain.P) or (P.O = $FFFF);
  Exit:
end;

procedure ShowBuffers;
label
  Exit;
var
  Count :byte;
  P,N   :WorkPointer;
begin
  HeadLine('Die Buffer');
  P.WP:=Dosinfo.DS^.Pbuf;
  N.WP:=Dosinfo.DS^.Prt;
  Count:=0;
  repeat
    with P.BH^ do
    begin
      writeln;
      write('DOS-Puffer Nr. ',Count,'; ');
      writeln('auf Adresse: ',W(DH,P.BH),'; Link: ',W(DH,Link),'; ');
      write('Zugeordnetes Laufwerk: ',Drv,'; ');
      if Drv <> 255 then writeln('Pfadname: ',W(SZ,N.DN^[Drv].Drn))
      else writeln(' ***');
      write('Bufferstatus: ',W(BB,Uid),'; ');
      write('Sektor: ',W(UI,Sec),'; ');
      writeln('Zugeordneter DPB:  ',W(DH,P.BH^.Pdpb));
      writeln;
      P.P:=Link;
      Count:=succ(Count)
    end;
    if DoAbort then goto Exit
  until P.P = Endchain.P;
  writeln;
  writeln('"Buffers = ',Count,'"');
  writeln;
  Exit:
end;

procedure ShowMemMap;
label
  Exit;
var
  Lastheadder  :boolean;
  Envirspace   :integer;
  P,WP2,R,VX,Q :WorkPointer;
  Vecnum       :integer;
  Segvec,
  Segpsp,
  Segpla,
  Segenvir,
  Segmcb       :integer;
begin
  HeadLine(' Systemspeicherbelegung ');
  P.WP:=Dosinfo.DS^.Pfab;
  write('Adresse':9,' ID':2,' PSP':5,' Bytes':6);
  writeln('    Type        Name');
  writeln;
  write('0000:0000':9,' -':2,'-----':5);
  writeln('  1019       "Vector-Table       fest"');
  write('0040:0000':9,' -':2,'-----':5);
  writeln('   767       "BIOS Datenbereich  fest"');
  write('0070:0000':9,' -':2,'-----':5);
  writeln('             "IO.SYS"');
  repeat
    with P.MH^ do
    begin
      Lastheadder:=ID = 'Z';
      Segmcb:=P.S;
      Segpsp:=Psp;
      Segpla:=P.S+P.MH^.Len;
      write(W(DH,P):9,W(CC,ID):2,W(WH,Psp):5,W(UIS,Len):7);
      if Segpsp = 0 then write('freier Speicher':18)
      else
      begin
        WP2:=P;
        WP2.S:=WP2.MH^.Psp;
        if Segmcb+1 = Segpsp then
        begin
          write('Program':15);
          WP2.S:=WP2.PP^.Env;
          if (WP2.S = 0) or (Segpsp <> memw[WP2.S-1:1]) then
            write(', aber leider kein Taskname verfuegbar')
          else
          begin
            WP2.S:=WP2.S-1;
            Envirspace:=WP2.MH^.Len*16;
            WP2.S:=WP2.S+1;
            repeat
              WP2.O:=WP2.O+1
            until (WP2.I^ = 0) or (WP2.O >= Envirspace);
            WP2.O:=WP2.O+3;
            if WP2.O > Envirspace then write('Kein Taskname gefunden')
            else write(W(SZ,WP2.P^))
          end;
          if Processvectors then
          begin
            writeln;
            writeln('':28,'Interruptvektoren');
            VX.P:=addr(Vecnum);
            for Vecnum:=0 to 255 do
            begin
              Segvec:=Vecarry[Vecnum].S;
              if (Segvec >= Segpsp) and (Segvec < Segpla) then
                writeln(W(BH,VX.P^):35,'  ',Vectorname(Vecnum))
            end
          end;
          if Processpspinfo then
          begin
            Q.S:=Segpsp;
            Q.O:=0;
            with Q.PP^ do
            begin
              writeln;
              writeln('Break-Adresse: ':50,W(DH,Ctrlc):9);
              writeln('Error-Adresse: ':50,W(DH,Hrder):9);
              writeln('Loader-Adresse: ':50,W(WH,Ldr):4);
              writeln('Environment-Segment: ':50,W(WH,Env):4)
            end
          end
        end
        else
        begin
          WP2.S:=WP2.PP^.Env;
          if WP2.S = P.S+1 then
          begin
            write('Environment':17);
            if Processenvironment then
            begin
              writeln;
              repeat
                writeln(W(SZ,WP2.P^));
                WP2.O:=WP2.O+length(W(SZ,WP2.P^))
              until WP2.I^ = 0
            end
          end
        end
      end;
      writeln;
      P.S:=Segpla+1
    end;
    if DoAbort then goto Exit
  until Lastheadder;
  Exit:
end;

procedure ShowVectors;
label
  Exit;
var
  Vecnum    :integer;
  Ptrvecnum :^integer;
begin
  HeadLine('Vektor   Adresse                 Funktion');
  Ptrvecnum:=addr(Vecnum);
  for Vecnum:=0 to 255 do
  begin
    write(Vecnum:3,W(BH,Ptrvecnum^):3);
    write(W(DH,Vecarry[Vecnum]):10,VectorName(Vecnum):40);
    if Vecarry[Vecnum].B^ = $CF then write(' IRET ');
    writeln;
    if (Vecnum mod 20) = 19 then if DoAbort then goto Exit
  end;
  Exit:
end;

procedure ShowDrives;
var
  P     :WorkPointer;
  Count :byte;
begin
  HeadLine('Laufwerke');
  P.WP:=Dosinfo.DS^.Prt;
  Count:=0;
  repeat
    with P.DN^[Count] do
    begin
      writeln('Drive ',char(Count+65),' -> ',W(SZ,Drn));
      write(' Status?? ',W(BB,U3));
      write(' Adresse DPB:  ',W(DH,Pdd));
      if Clu <> $FFFF then write(' Dir-Cluster ',W(UI,Clu));
      write(' ID ',W(BH,Id));
      writeln
    end;
    Count:=succ(Count)
  until Count > 10
end;

procedure ShowDeviceDriver;
label
  Exit;
var
  P   :WorkPointer;
  L,A :integer;
begin
  P.WP:=Dosinfo.DS^.Pddrv2;
  HeadLine('Device-Drivers');
  repeat
    write('Header-Adresse: ',W(DH,P),'; ');
    writeln('Attribute : ',W(BB,P.DD^.Attr),', ');
    A:=P.DD^.Attr;
    if (A and $8000) <> 0 then writeln('Character-Device')
    else writeln('Block-Device');
    if (A and $4000) <> 0 then writeln('IO-Control');
    if (A and $0008) <> 0 then writeln('Clock-Device');
    if (A and $0004) <> 0 then writeln('NUL-Device');
    if (A and $0002) <> 0 then writeln('Standard-Input-Device');
    if (A and $0001) <> 0 then writeln('Standard-Output-Device');
    write('Strategy-Entry:  ',W(WH,P.DD^.Strat),'; ');
    writeln('Interrupt-Entry: ',W(WH,P.DD^.Intr),'; ');
    if (A and $8000) <> 0 then
    begin
      write('Name: ');
      for L:=0 to 7 do write(P.DD^.Nam[L])
    end
    else write(P.DD^.Num,' Subeinheiten');
    writeln;
    writeln('Link: ',W(DH,P.DD^.Link));
    P.P:=P.DD^.Link;
    if DoAbort then goto Exit
  until P.O = $FFFF;
  Exit:
end;

procedure ShowHelp;
begin
  writeln('?  Kommandouebersicht:');
  writeln;
  writeln('  Q,<ESC> Ende           ?    Hilfe ');
  writeln('  I    DOS-Info-Block    P    DOS-Parameter-Blocks');
  writeln('  B    Buffer            L    Laufwerke');
  writeln('  M    Memory-Map        V    Vektoren');
  writeln('  D    Device-Driver');
  writeln
end;

procedure CmdDispatcher;
label
  Exit;
var
  Usercmd :char;
begin
  writeln(' DOS-Memory-Map (c) 1987 c"t');
  writeln;
  ShowHelp;
  repeat
    write(#13,#240);
    read(kbd,Usercmd);
    case upcase(Usercmd) of
      'Q',#$1B :goto Exit;
      '?'      :ShowHelp;
      'I'      :ShowDosInfo;
      'P'      :ShowDosParameterBlocks;
      'B'      :ShowBuffers;
      'L'      :ShowDrives;
      'M'      :ShowMemMap;
      'V'      :ShowVectors;
      'D'      :ShowDeviceDriver
    end
  until false;
  Exit:
end;

begin
  InitDosInfo;
  CmdDispatcher
end.
