program MSDOS_Reformatter;
const
  Bufgr = 2047;
  Titel = ^M^J'MSDOS-Reformatter V2.0 vom 5.8.1988';
var
  Buffer                        :array[0..Bufgr] of byte;
  Psize,Secptrk,Lsecptrk,Heads,
  Tracks,Sektoren,Reservsec,
  Eintraege,Fatsecs,Ident       :integer;
  Secpcl,Fatzahl,Medium,
  Msdrive,Logdrive,I            :byte;
  Eingabe                       :string[14];

function Ubios(Fn,Pa,Pbc,Pde,Phl :integer):integer;
var
  Biospb :record
    Func,A   :byte;
    Bc,De,Hl :integer
  end;
  Result :integer;
begin
  with Biospb do
  begin
    Func:=Fn; A:=Pa;
    Bc:=Pbc; De:=Pde; Hl:=Phl
  end;
  Result:=0;
  case Fn of
    2,3,7,13..15,17..19,24 : Result:=bdos(50,addr(Biospb));
    9,16,20,22,25          : Result:=bdoshl(50,addr(Biospb))
  else bdos(50,addr(Biospb))
  end;
  Ubios:=Result
end;

procedure Rwsector(Abssec :integer; Wflag :boolean; Buf :integer);
var
  Trk,Sec,K :integer;
  Dph       :^integer absolute K;
begin
  Abssec:=pred(Abssec);
  Trk:=Abssec div Lsecptrk;
  Sec:=Abssec mod Lsecptrk;
  K:=Ubios(9,0,Msdrive,1,0);
  Sec:=Ubios(16,0,Sec,Dph^,0);
  K:=Ubios(23,0,1,0,0);
  K:=Ubios(10,0,Trk,0,0);
  K:=Ubios(11,0,Sec,0,0);
  K:=Ubios(12,0,Buf,0,0);
  K:=Ubios(28,1,0,0,0);
  if Wflag then K:=Ubios(14,0,0,0,0) else K:=Ubios(13,0,0,0,0)
end;

procedure Mslogin;
type
  Dpb = record
    Spt         :integer;
    Bsh,Blm,Exm :byte;
    Dsm,Drm     :integer;
    Al0,Al1     :byte;
    Cks,Off     :integer;
    Psh,Phm     :byte
  end;
var
  K   :integer;
  Ptr :^Dpb absolute K;
begin
  K:=Ubios(9,0,Msdrive,0,0);
  bdos(14,Msdrive);
  K:=bdoshl(31);
  Psize:=128 shl Ptr^.Psh
end;

procedure Relog(Drive :byte);
var
  K :integer;
begin
  K:=Ubios(9,0,Drive,1,0);
  bdos(14,Drive)
end;

procedure Writefat;
var
  I,J,Sec :integer;
begin
  for I:=1 to Fatzahl do
  begin
    Sec:=Reservsec+pred(I)*Fatsecs;
    for J:=1 to Fatsecs do Rwsector(Sec+J,true,addr(Buffer[Psize*pred(J)]))
  end
end;

procedure Calculate_ibm;
begin
  Reservsec:=1; Fatzahl:=2; Tracks:=40;
  case Ident of
    160 : begin
            Heads:=1; Secpcl:=1; Secptrk:=8;
            Fatsecs:=1; Eintraege:=64
          end;
    180 : begin
            Heads:=1; Secpcl:=1; Secptrk:=9;
            Fatsecs:=2; Eintraege:=64
          end;
    320 : begin
            Heads:=2; Secpcl:=2; Secptrk:=8;
            Fatsecs:=1; Eintraege:=112
          end;
    360 : begin
            Heads:=2; Secpcl:=2; Secptrk:=9;
            Fatsecs:=2; Eintraege:=112
          end
  end
end;

procedure Input_data;
begin
  write('Seitenzahl       : '); readln(Heads);
  write('Spurzahl         : '); readln(Tracks);
  write('Sektoren/Spur    : '); readln(Secptrk);
  write('Boot-Sektoren    : '); readln(Reservsec);
  write('Anzahl FATs      : '); readln(Fatzahl);
  write('Sektoren/FAT     : '); readln(Fatsecs);
  write('DIR-Eintraege    : '); readln(Eintraege);
  write('Sektoren/Cluster : '); readln(Secpcl)
end;

procedure Reformat;
const
  Oem :array[1..8] of char = 'WOL V2.0';
var
  I,S :integer;
begin
  Sektoren:=Tracks*Secptrk*Heads;
  Lsecptrk:=Secptrk*Heads;
  Medium:=$7C+byte(Heads = 2)+byte(Secptrk = 8) shl 1+byte(Tracks <> 80) shl 7;
  Rwsector(1,false,addr(Buffer));
  fillchar(Buffer,32,0);
  move(Oem,Buffer[3],8);
  Buffer[$0B]:=lo(Psize);
  Buffer[$0C]:=hi(Psize);
  Buffer[$0D]:=Secpcl;
  Buffer[$0E]:=Reservsec;
  Buffer[$0F]:=0;
  Buffer[$10]:=Fatzahl;
  Buffer[$11]:=lo(Eintraege);
  Buffer[$12]:=hi(Eintraege);
  Buffer[$13]:=lo(Sektoren);
  Buffer[$14]:=hi(Sektoren);
  Buffer[$15]:=Medium;
  Buffer[$16]:=Fatsecs;
  Buffer[$17]:=0;
  Buffer[$18]:=Secptrk;
  Buffer[$19]:=0;
  Buffer[$1A]:=Heads;
  Buffer[$1B]:=0;
  Rwsector(1,true,addr(Buffer));
  fillchar(Buffer,succ(Bufgr),0);
  Buffer[0]:=Medium;
  Buffer[1]:=$FF;
  Buffer[2]:=$FF;
  Writefat;
  fillchar(Buffer,1024,$F6);
  for I:=0 to 32 do Buffer[I shl 5]:=0;
  S:=Reservsec+Fatzahl*Fatsecs;
  for I:=succ(S) to S+Eintraege shl 5 div Psize do Rwsector(I,true,addr(Buffer))
end;

begin
  Logdrive:=bdos(25);
  writeln(Titel);
  repeat
    write(^M^J'Laufwerk mit MSDOS-Diskette : ');
    readln(Eingabe);
    Msdrive:=ord(upcase(Eingabe[1]))-$41
  until Msdrive = 8;
  write('Hinweis: phys. Disk-Parameter muessen korrekt gesetzt sein !'^M^J^J);
  repeat
    Mslogin;
    Ident:=0;
    if Psize = 512 then
    begin
      write('Kapazitaet in kB (nur IBM) : ');
      readln(Ident)
    end;
    case Ident of
      160,180,320,360 : Calculate_ibm
    else Input_data
    end;
    repeat
      Reformat;
      write('Weitere Diskette gleiche Daten (J/N) ? ');
      readln(Eingabe)
    until (length(Eingabe) = 0) or (upcase(Eingabe[1]) = 'N');
    write('Weitere Diskette andere Daten (J/N) ? ');
    readln(Eingabe)
  until (length(Eingabe) = 0) or (upcase(Eingabe[1]) = 'N');
  Relog(Logdrive)
end.
