program PackAus;
type
  Laufwerksnamen_Typ =string[2];
  StatusTyp          =(Neutralzeile,Titelzeile,Schlusszeile);
  ZeilenTyp          =string[100];
  NamensTyp          =string[14];
  Betriebsart_Typ    =record
    Warnen               :boolean;
    Ziel_Laufwerk        :Laufwerksnamen_Typ;
    Quelldateiname,Maske :NamensTyp
  end;
  S7typ =string[7];
  S8typ =string[8];
  Styp  =string[255];
var
  Fi :text;
  Betriebsart :Betriebsart_Typ;

procedure Entpack_Gruppe(E :S7typ; var A :S8typ);
const
  Msb :byte =$80;
  Ascii_Maske =$7F;
var
  M,N :byte;

begin
  M:=1; A[0]:=char(8); A[8]:=char(0);
  for N:=1 to 7 do A[N]:=char(byte(E[N]) and Ascii_Maske);
  for N:=1 to 7 do
  begin
    if (byte(E[N]) and Msb) > 0 then A[8]:=char(byte(A[8]) or M);
    M:=M*2
  end;
  if A[8] = char(0) then delete(A,8,1)
end;

procedure Entpack_Zeile(var E,A :Styp);
var
  S7 :S7typ; S8 :S8typ;

begin
  A:='';
  while length(E) > 6 do
  begin
    S7:=copy(E,1,7);
    delete(E,1,7);
    Entpack_Gruppe(S7,S8);
    A:=A+S8
  end;
  A:=A+E
end;

procedure Initialisierung(var P :Betriebsart_Typ);
var
  S :NamensTyp;
  N :byte;
  Eingabe_Richtig :boolean;

begin
  writeln(^M^J'----------------------------------------------------------------');
  repeat
    write('+++ Vorname der Mutterdatei (<CR>:"DOSCalls"): ................. ');
    readln(S);
    Eingabe_Richtig:=pos('.',S) = 0;
    if not Eingabe_Richtig then writeln(^G'--- Nachnamen bitte nicht angeben.-')
  until Eingabe_Richtig;
  if S = '' then P.Quelldateiname:='DOSCALLS.BIB' else P.Quelldateiname:=S+'.BIB';
  repeat
    write('+++ Ziel-Laufwerk fuer Tochterdateien (<CR>: Vorwahl-LW): ...... ');
    readln(S);
    if copy(S,2,1) = ':' then delete(S,2,1);
    Eingabe_Richtig:=(S = '') or ((length(S) = 1) and (S[1] in ['A'..'P','a'..'p']));
    if not Eingabe_Richtig then writeln(^G)
  until Eingabe_Richtig;
  if S <> '' then S:=S+':';
  P.Ziel_Laufwerk:=S;
  write('+++ Auswahl-Maske Vornamen der Tochter-Dateien (<CR>: "*"): .... ');
  repeat
    readln(S);
    Eingabe_Richtig:=(S = '') or ((pos(S,'.') = 0) and (length(S) <= 8));
    if not Eingabe_Richtig then write(^G)
  until Eingabe_Richtig;
  for N:=1 to length(S) do S[N]:=upcase(S[N]);
  while length(S) < 8 do S:=S+'?';
  P.Maske:=S;
  write('+++ Toechter ohne Warnung ueberschreiben (J/N; <CR> = "J"): .... ');
  repeat
    readln(S); S[1]:=upcase(S[1]);
    Eingabe_Richtig:=(S = '') or (S = 'J') or (S = 'N');
    if not Eingabe_Richtig then write(^G)
  until Eingabe_Richtig;
  Betriebsart.Warnen:=(S = 'N');
  writeln('----------------------------------------------------------------')
end;

function Maskendeckung(N :NamensTyp; B :Betriebsart_Typ):boolean;
var
  Index :byte;
  Zeichendeckung :boolean;

begin
  if B.Maske = '????????' then Maskendeckung:=true
  else
  begin
    Index:=0;
    if pos('.',N) > 0 then N:=copy(N,1,pos('.',N)-1);
    while length(N) < 8 do N:=N+' ';
    repeat
      Index:=Index+1;
      Zeichendeckung:=(upcase(N[Index]) = B.Maske[Index]) or (B.Maske[Index] = '?')
                      or (B.Maske[Index] = '*')
    until (not Zeichendeckung) or (Index = length(N)) or (B.Maske[Index] = '*')
                               or (N[Index+1] = '.');
    Maskendeckung:=Zeichendeckung
  end
end;

function Zeilenstatus(P :ZeilenTyp):StatusTyp;
begin
  if pos('END.',P) = 1 then Zeilenstatus:=Schlusszeile
  else if pos('$$$',P) = 1 then Zeilenstatus:=Titelzeile
       else Zeilenstatus:=Neutralzeile
end;

function Namensteil(P :ZeilenTyp):NamensTyp;
begin
  delete(P,1,3);
  Namensteil:=P
end;

function Schreibbereit(var Fo :text; NN :Namenstyp; Warnung_Gefordert :boolean):boolean;
label
  Exit;
var
  C :char;

begin
  assign(Fo,NN);
  if Warnung_Gefordert then
  begin
    {$I-} reset(Fo) {$I+};
    if IOResult = 0 then
    begin
      write('+++ Datei ',NN,' existiert. Ueberschreiben (J/N)? ');
      repeat
        read(kbd,C); C:=upcase(C);
        if not (C in ['J','N']) then write(^G)
      until C in ['J','N'];
      writeln;
      if C = 'N' then
      begin
        Schreibbereit:=false;
        goto Exit
      end
    end
  end;
  {$I-} rewrite(Fo) {$I+};
  if IOResult > 0 then
  begin
    writeln(^G'--- Tochterdatei ',NN,': Rewrite-Fehler.-');
    Schreibbereit:=false
  end
  else Schreibbereit:=true;
Exit:
end;

function Zeile:Styp;
var
  E,A :Styp;

begin
  readln(Fi,E);
  Entpack_Zeile(E,A);
  Zeile:=A
end;

procedure Job;
label
  Exit;
var
  Z  :ZeilenTyp;
  S  :StatusTyp;
  N  :NamensTyp;
  Fo :text;

begin
  Z:='';
  repeat
    while (Zeilenstatus(Z) <> Titelzeile) and not eof(Fi) do Z:=Zeile;
    if eof(Fi) then goto Exit;
    N:=Namensteil(Z);
    writeln('+++ In Mutter-Datei gefunden: ',N,'.-');
    if not Maskendeckung(N,Betriebsart) then goto Exit;
    N:=Betriebsart.Ziel_Laufwerk+N;
    if not Schreibbereit(Fo,N,Betriebsart.Warnen) then goto Exit;
    writeln('+++ Tochterdatei wird angelegt.-');
    repeat
      Z:=Zeile;
      S:=Zeilenstatus(Z);
      if (S <> Titelzeile) and (pos('.',Z) <> 1) and (pos('{.',Z) <> 1) then writeln(Fo,Z)
    until (S = Schlusszeile) or (S = Titelzeile) or eof(Fi);
    close(Fo)
  until eof(Fi);
Exit:
end;

begin {PackAus}
  clrscr;
  writeln('======================');
  writeln('PackAus (Wol/12-09-86)');
  writeln('======================'^M^J);
  writeln('PackAus dient zur Erzeugung von Tochterdateien aus DOSCalls.BIB oder');
  writeln('anderer Mutter-Dateien mit dem Nachnamen ".BIB" ("Baustein-Bibliothek").');
  writeln('Dabei kann das Ziel-Laufwerk angegeben werden (Ersatzwert ist das');
  writeln('vorgewaehlte Laufwerk).-');
  writeln('PackAus entpackt Dateien mit und ohne Daten-Konzentration.');
  writeln('Bei I/O-Fehlern bricht das Programm im Kompilat ab.');
  Initialisierung(Betriebsart);
  assign(Fi,Betriebsart.Quelldateiname); {$I-} reset(Fi) {$I+};
  if IOResult > 0 then
  begin
    writeln(^M^J^G'--- ',Betriebsart.Quelldateiname,' nicht gefunden.');
    writeln('Programm PackAus wird abgebrochen.-');
    halt
  end;
  repeat Job until eof(Fi);
  writeln(^M^J'+++ Programm PackAus beendet.-')
end.

