program Huffman;
type
  Eintrag     = (Blatt,Knoten);
  PtrNode     = ^Node;
  Node        = record
    Ptrl,Ptrr :PtrNode;
    Anz       :integer;
    case
      Art : Eintrag of Blatt :(ASCII :0..255)
  end;
  Tabelle     = array[0..255] of Node;
  String20    = string[20];
  CodeTabelle = array[0..255] of String20;
var
  Feld       :Tabelle;
  Tafel      :CodeTabelle;
  Zeichen    :char;
  Zaehler,I  :integer;
  Quelle     :text;
  Ziel       :file of byte;
  Wurzel     :PtrNode;
  Entropie   :real;
  MittelPfad :real;

procedure File_Oeffnen;
var
  Ok                 :boolean;
  QuellName,ZielName :string[30];
begin
  repeat
    writeln;
    write('Codiere das File: ');
    readln(QuellName);
    assign(Quelle,QuellName);
    {$I-} reset(Quelle) {$I+};
    Ok:=(ioresult = 0);
    if not Ok then writeln('File ',QuellName:length(QuellName),' nicht vorhanden')
  until Ok;
  if pos('.',QuellName) > 0 then ZielName:=copy(QuellName,1,pos('.',QuellName))+'cod'
  else ZielName:=QuellName+'.cod';
  writeln('File ',QuellName:length(QuellName),
          ' wird in ',ZielName:length(ZielName),' uebersetzt');
  assign(Quelle,QuellName);
  assign(Ziel,ZielName);
  reset(Quelle);
  rewrite(Ziel)
end;

procedure Sort(var Feld :Tabelle; Max :integer);
var
  Index     :integer;
  Getauscht :boolean;

function Tausche(var A,B :Node):boolean;
var
  Temp :Node;
begin
  Temp:=A;
  A:=B;
  B:=Temp;
  Tausche:=true
end;

begin
  repeat
    Getauscht:=false;
    for Index:=Max downto 1 do
      if Feld[Index].Anz > Feld[Index-1].Anz then Getauscht:=Tausche(Feld[Index],Feld[Index-1])
  until not Getauscht
end;

function Baum_Erzeugen(Feld :Tabelle):PtrNode;
var
  Grad                                     :integer;
  Neues_Element,Rechter_Nachf,Linker_Nachf :^Node;

function Reduziere(var Feld :Tabelle):integer;
var
  Zaehler,I,J :integer;
begin
  Zaehler:=0;
  for I:=255 downto 0 do
    if Feld[I].Anz > 0 then Zaehler:=Zaehler+1
    else for J:=I to 254 do Feld[J]:=Feld[J+1];
  Reduziere:=Zaehler-1
end;

begin
  Grad:=Reduziere(Feld);
  while Grad > 0 do
  begin
    Sort(Feld,Grad);
    new(Rechter_Nachf);
    new(Linker_Nachf);
    Rechter_Nachf^:=Feld[Grad];
    Linker_Nachf^:=Feld[Grad-1];
    with Feld[Grad-1] do
    begin
      Art:=Knoten;
      Ptrl:=Linker_Nachf;
      Ptrr:=Rechter_Nachf;
      Anz:=Rechter_Nachf^.Anz+Linker_Nachf^.Anz
    end;
    Grad:=Grad-1
  end;
  new(Neues_Element);
  Neues_Element^:=Feld[0];
  Baum_Erzeugen:=Neues_Element
end;

procedure Tabelle_Erzeugen(Wurzel :PtrNode; var Temp :CodeTabelle);

{$A-}
procedure Umwandeln(Baum_Element :PtrNode; Bin :String20);
begin
  with Baum_Element^ do
    if Art <> Blatt then
    begin
      Umwandeln(Ptrl,Bin+'0');
      Umwandeln(Ptrr,Bin+'1')
    end
    else
    begin
      Temp[ASCII]:=Bin;
      Entropie:=Entropie+Feld[ASCII].Anz*ln(Feld[ASCII].Anz/Zaehler);
      MittelPfad:=MittelPfad+length(Bin)*Anz
    end
end;
{$A+}

procedure Init(var Tab :CodeTabelle);
var
  I :integer;
begin
  for I:=0 to 255 do Tab[I]:=''
end;

begin
  Init(Temp);
  Entropie:=0;
  MittelPfad:=0;
  Umwandeln(Wurzel,'');
  Entropie:=-Entropie/Zaehler/ln(2);
  MittelPfad:=MittelPfad/Zaehler;
  writeln('Entropie der Verteilung: ',Entropie);
  writeln('Mittlere Codelaenge    : ',MittelPfad)
end;

function Zwei_Hoch(Exponent :byte):byte;
var
  I,Erg :byte;
begin
  Erg:=1;
  for I:=1 to Exponent do Erg:=Erg*2;
  Zwei_Hoch:=Erg
end;

procedure Code_Ausgabe(var Tafel :CodeTabelle; Anzahl :integer; Wurzel :PtrNode);
var
  Akt_Bit  :0..7;
  Akt_Byte :byte;

procedure Anzahl_Schreiben(Anz :integer);
var
  Hibyt,Lobyt :byte;
begin
  Hibyt:=Anz div 256;
  write(Ziel,Hibyt);
  Lobyt:=Anz mod 256;
  write(Ziel,Lobyt)
end;

procedure Bit_Schreiben(Chr :char);
var
  Bit,Fehler :integer;
begin
  val(Chr,Bit,Fehler);
  Akt_Byte:=Akt_Byte+Zwei_Hoch(7-Akt_Bit)*Bit;
  if Akt_Bit = 7 then
  begin
    write(Ziel,Akt_Byte);
    Akt_Bit:=0;
    Akt_Byte:=0
  end
  else Akt_Bit:=Akt_Bit+1
end;

{$A-}
procedure Baum_Schreiben(Zeiger :PtrNode);
var
  Index,Zahl :byte;
  Bit        :string[1];
begin
  if Zeiger^.Art = Blatt then
  begin
    Bit_Schreiben('0');
    Zahl:=Zeiger^.ASCII;
    for Index:=1 to 8 do
    begin
      str(Zahl mod 2,Bit);
      Bit_Schreiben(Bit);
      Zahl:=Zahl div 2
    end
  end
  else
  begin
    Bit_Schreiben('1');
    Baum_Schreiben(Zeiger^.Ptrl);
    Baum_Schreiben(Zeiger^.Ptrr)
  end
end;
{$A+}

procedure Code_Schreiben(var Tafel :CodeTabelle);
var
  Zeichen :char;
  Index   :byte;
begin
  reset(Quelle);
  while not eof(Quelle) do
  begin
    read(Quelle,Zeichen);
    for Index:=1 to length(Tafel[ord(Zeichen)]) do
      Bit_Schreiben(copy(Tafel[ord(Zeichen)],Index,1))
  end;
  while Akt_Bit > 0 do Bit_Schreiben('0')
end;

begin
  Anzahl_Schreiben(Anzahl);
  Akt_Bit:=0; Akt_Byte:=0;
  writeln('Start Baum schreiben');
  Baum_Schreiben(Wurzel);
  writeln('Start Code schreiben');
  Code_Schreiben(Tafel)
end;

begin
  for I:=0 to 255 do
    with Feld[I] do
    begin
      Art:=Blatt;
      Ptrl:=nil;
      Ptrr:=nil;
      ASCII:=I;
      Anz:=0
    end;
  Zaehler:=0;
  File_Oeffnen;
  while not eof(Quelle) do
  begin
    read(Quelle,Zeichen);
    Feld[ord(Zeichen)].Anz:=Feld[ord(Zeichen)].Anz+1;
    Zaehler:=Zaehler+1
  end;
  writeln('Nun wird der Baum gepflanzt');
  Wurzel:=Baum_Erzeugen(Feld);
  writeln('Seine Blaetter liefert der Code');
  Tabelle_Erzeugen(Wurzel,Tafel);
  Code_Ausgabe(Tafel,Zaehler,Wurzel);
  writeln('Das wars');
  close(Quelle);
  close(Ziel)
end.
