program TPrint;
const
  MaxRecs   = 10;
  BufSize   = 1280;
  Ph_Hyphen = #31;
  Ph_Space  = #15;
  CR        = #13;
  LF        = #10;
  CRLF      = #13#10;
  BoldOn    = #27#$46;
  BoldOff   = #27#$26;
  UndlOn    = #27#$45;
  UndlOff   = #27#$52;
  SlantOn   = #27#$57;
  SlantOff  = #27#$26;
  SubsOn    = #27#$55;
  SubsOff   = #27#$44;
  SupsOn    = #27#$44;
  SupsOff   = #27#$55;
  IniStr    = #27#13#$50;
  UniStr    = #$13;
var
  InFile   :file;
  EndFile,
  EndBuf,
  PrintOn  :boolean;
  InBuf,
  PStart,
  PEnd,
  PCount   :integer;
  FName    :string[14];
  Buffer   :array[1..BufSize] of byte;

procedure SetOpen;
begin
  if paramcount = 0 then
  begin
    write('Name der auszudruckenden Datei: ');
    readln(FName)
  end
  else FName:=paramstr(1);
  assign(InFile,FName);
  {$I-} reset(InFile); {$I+}
  if ioresult <> 0 then
  begin
    close(InFile);
    writeln('Nicht gefunden: ',FName);
    halt
  end
end;

function GetCh :char;
var
  RecsGot :integer;
begin
  if EndBuf then
  begin
    blockread(InFile,Buffer,MaxRecs,RecsGot);
    EndBuf:=false;
    InBuf:=1;
    if RecsGot = 0 then
    begin
      writeln('Unexpected EOF!');
      close(InFile);
      halt
    end
  end;
  GetCh:=chr(Buffer[InBuf] and 127);
  InBuf:=InBuf+1;
  if InBuf > BufSize then EndBuf:=true
end;

procedure PrintFile;
var
  Bold,Slant,Undl,Subs,Sups,UndlSet,NewLine,Page :boolean;
  POffs,MTop,MBot,PLen,PNumber,LCount,HPos,X     :integer;
  Ch                                             :char;

procedure ResetPrt;
begin
  write(lst,BoldOff);
  write(lst,UndlOff);
  UndlSet:=false
end;

procedure SetPrt;
begin
  if Bold then write(lst,BoldOn);
  if Slant then write(lst,SlantOn);
  if Subs then write(lst,SubsOn);
  if Sups then write(lst,SupsOn)
end;

procedure PrintPn;
var
  X :integer;
begin
  if Page then
  begin
    ResetPrt;
    write(lst,CRLF);
    write(lst,CRLF);
    for X:=1 to 37+POffs do write(lst,' ');
    if PNumber < 10 then write(lst,' ');
    write(lst,'- ',PNumber,' -',CRLF);
    write(lst,#12);
    SetPrt
  end
  else
  begin
    write(lst,CRLF);
    write(lst,#12)
  end
end;

procedure NextLine;
begin
  LCount:=LCount+1;
  if LCount >= (PLen-MTop-MBot) then
  begin
    LCount:=0;
    if PrintOn then PrintPn;
    PNumber:=PNumber+1;
    PCount:=PCount+1;
    if PCount >= (PStart-1) then PrintOn:=true;
    if (PCount >= PEnd) and (PEnd <> 0) then EndFile:=true
  end
end;

procedure LastPage;
begin
  if not NewLine then
  begin
    if PrintOn then write(lst,CRLF);
    NextLine
  end;
  while (LCount <> 0) do
  begin
    if PrintOn then write(lst,CRLF);
    NextLine
  end
end;

procedure DoDotCmd;
const
  CmdChars                         = 19;
  Cmds :array[2..CmdChars] of char = 'MTMBPLPNPOPAOPLHCW';
var
  CmdNum,Arg,Ok,X :integer;
  ArgStr          :string[5];
  Line            :string[120];
begin
  Line:='';
  repeat
    Ch:=GetCh;
    Line:=Line+upcase(Ch)
  until Ch = chr(10);
  if length(Line) < 2 then exit;
  CmdNum:=0;
  for X:=1 to CmdChars div 2 do
    if (Line[1] = Cmds[X*2]) and (Line[2] = Cmds[X*2+1]) then CmdNum:=X;
  if CmdNum = 0 then exit;
  if CmdNum < (CmdChars div 2)-1 then
  begin
    X:=3;
    while (Line[X] = ' ') and (X <= length(Line)) do X:=X+1;
    ArgStr:='';
    while (Line[X] in ['0'..'9']) do
    begin
      ArgStr:=ArgStr+Line[X];
      X:=X+1
    end;
    val(ArgStr,Arg,Ok);
    if Ok <> 0 then exit
  end;
  case CmdNum of
    1 : MTop:=Arg;
    2 : MBot:=Arg;
    3 : PLen:=Arg;
    4 : PNumber:=Arg;
    5 : POffs:=Arg;
    6 : LastPage;
    7 : Page:=false;
    8 : write(lst,#27#$1E,chr(Arg));
    9 : write(lst,#27#$1F,chr(Arg))
  end
end;

procedure TestStop;
var
  Ch :char;
begin
  gotoxy(25,10); write('* Druck unterbrochen *');
  gotoxy(26,12); write('A: Abbruch   W: Weiter');
  repeat
    gotoxy(50,12); read(kbd,Ch);
    Ch:=upcase(Ch); write(Ch)
  until Ch in ['A','W'];
  if Ch = 'A' then EndFile:=true;
  delay(500);
  gotoxy(25,10); clreol;
  gotoxy(26,12); clreol
end;

begin
  Bold:=false; Slant:=false; Undl:=false;
  UndlSet:=false; Subs:=false; Sups:=false;
  NewLine:=true; EndBuf:=true; EndFile:=false;
  MTop:=0; MBot:=11; POffs:=2; PLen:=72; PNumber:=1;
  LCount:=0; HPos:=1; Page:=true;
  repeat
    Ch:=GetCh;
    if (Ch = '.') and NewLine then DoDotCmd
    else
    begin
      if Ch = Ph_Space then Ch:=' ';
      if Ch = Ph_Hyphen then Ch:='-';
      if Ch < ' ' then
        case Ch of
          ^B : begin
                 Bold:=not Bold;
                 if Bold then write(lst,BoldOn)
                 else write(lst,BoldOff)
               end;
          ^C : TestStop;
          ^D : begin
                 Slant:=not Slant;
                 if Slant then write(lst,SlantOn)
                 else write(lst,SlantOff)
               end;
          ^H : if PrintOn then write(lst,Ch);
          ^I : if PrintOn then
                 for X:=HPos to (HPos div 8)*8+8 do
                 begin
                   write(lst,' ');
                   HPos:=HPos+1
                 end;
          ^J : begin
                 if PrintOn then write(lst,LF);
                 NextLine
               end;
          ^M : begin
                 if PrintOn then write(lst,CR);
                 NewLine:=true;
                 HPos:=1;
                 UndlSet:=false;
                 if Undl then write(lst,UndlOff)
               end;
          ^S : begin
                 Undl:=not Undl;
                 UndlSet:=false;
                 if not Undl then write(lst,UndlOff)
               end;
          ^T : begin
                 Sups:=not Sups;
                 if Sups then write(lst,SupsOn)
                 else write(lst,SupsOff)
               end;
          ^V : begin
                 Subs:=not Subs;
                 if Subs then write(lst,SubsOn)
                 else write(lst,SubsOff)
               end;
          ^Z : begin
                 LastPage;
                 EndFile:=true
               end;
         #30 :
        end
      else
      begin
        if NewLine then
        begin
          NewLine:=false;
          if PrintOn then
          begin
            ResetPrt;
            for X:=0 to POffs do write(lst,' ');
            SetPrt
          end
        end;
        if (UndlSet = false) and Undl and (Ch <> ' ') then
        begin
          UndlSet:=true;
          write(lst,UndlOn)
        end;
        if PrintOn then write(lst,Ch);
        HPos:=HPos+1
      end
    end;
    if keypressed then
    begin
      read(kbd,Ch);
      TestStop
    end
  until EndFile
end;

procedure SetParams;
var
  ParamsOk,X :integer;
  ArgStr     :string[5];
begin
  val(paramstr(2),PStart,ParamsOk);
  if (paramcount > 2) and (ParamsOk = 0) then
  begin
    val(paramstr(3),PEnd,ParamsOk);
    if PStart > PEnd then ParamsOk:=99
  end;
  if PStart > 1 then PrintOn:=false;
  if ParamsOk <> 0 then
  begin
    writeln('Falscher Parameter!');
    halt
  end
end;

procedure DspParams;
var
  Prompt :char;
begin
  clrscr;
  gotoxy(28,1); writeln('*** WordStar-Ausdruck ***');
  writeln; writeln;
  writeln('Auszudruckende Datei: ',FName);
  writeln('Start mit Seitennr. : ',PStart);
  write('Ende mit Seitennr.  : ');
  if PEnd = 0 then writeln('...') else writeln(PEnd);
  writeln;
  write('^C = Abbruch, <RETURN> = Weiter: ');
  readln(Prompt);
  gotoxy(1,9); clreol
end;

begin
  PCount:=0; PStart:=1; PEnd:=0; PrintOn:=true;
  if paramcount > 1 then SetParams;
  SetOpen;
  write('Drucker...');
  write(lst,IniStr);
  writeln('ok.');
  DspParams;
  PrintFile;
  write(lst,UniStr);
  close(InFile)
end.

